'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var rxdb = require('rxdb');
var axios = require('axios');
var mobx = require('mobx');
var merge = require('deepmerge');
var cashify = require('cashify');
var numeral = require('numeral');
var events = require('events');
var faker = require('faker');
var consola = require('consola');
var Subscriber = require('rxcollection-subscriber');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var axios__default = /*#__PURE__*/_interopDefaultLegacy(axios);
var merge__default = /*#__PURE__*/_interopDefaultLegacy(merge);
var numeral__default = /*#__PURE__*/_interopDefaultLegacy(numeral);
var faker__default = /*#__PURE__*/_interopDefaultLegacy(faker);
var consola__default = /*#__PURE__*/_interopDefaultLegacy(consola);
var Subscriber__default = /*#__PURE__*/_interopDefaultLegacy(Subscriber);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __spreadArray(to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
}

var version = require('../package.json').version;

var NODE_ENV$1 = process.env.NODE_ENV,
    browser$1 = process.browser;
var build = {
  db: {
    name: 'Lodger/$',
    adapter: NODE_ENV$1 === 'development' ? 'memory' : browser$1 ? 'idb' : 'leveldb',
    password: 'l0dg3rp4$$',
    ignoreDuplicate: Boolean(NODE_ENV$1 === 'test')
  }
};
var taxonomii = {
  defaults: {
    criteriu: {
      limit: 25,
      index: 0,
      sort: {},
      find: null
    }
  },
  asociatii: {
    criteriu: {
      limit: 100
    }
  }
};
var config = {
  version: version,
  taxonomii: taxonomii,
  build: build
};

// import fx from 'fx'
/**
 * Error logger
 */

var LodgerError =
/** @class */
function (_super) {
  __extends(LodgerError, _super);

  function LodgerError(m, details) {
    var _this = this;

    if (details) {
      m = String(m).replace('%%', "\"" + JSON.stringify(details) + "\"");
    }

    _this = _super.call(this, m) || this; // Set the prototype explicitly.

    Object.setPrototypeOf(_this, LodgerError.prototype);
    return _this;
  }

  return LodgerError;
}(Error);

// import { Currency } from './maintainable/currencies'

/**
 * Accepted -strings- for a LodgerSchema field's type
 *
 * @enum {number}
 */
var strings;

(function (strings) {
  strings[strings["buildingName"] = 0] = "buildingName";
  strings[strings["fullName"] = 1] = "fullName";
  strings[strings["search"] = 2] = "search";
  strings[strings["select"] = 3] = "select";
  strings[strings["serviceName"] = 4] = "serviceName";
  strings[strings["string"] = 5] = "string";
  strings[strings["textarea"] = 6] = "textarea";
  strings[strings["userAvatar"] = 7] = "userAvatar";
})(strings || (strings = {}));
/**
 * Accepted 'number's for a LodgerSchema field
 *
 * @enum {number}
 */


var numbers;

(function (numbers) {
  numbers[numbers["date"] = 0] = "date";
  numbers[numbers["dateTime"] = 1] = "dateTime";
  numbers[numbers["number"] = 2] = "number";
  numbers[numbers["rol"] = 3] = "rol";
  numbers[numbers["meter"] = 4] = "meter";
})(numbers || (numbers = {}));
/**
 * Accepted 'array's for a LodgerSchema field
 *
 * @enum {number}
 */


var arrays;

(function (arrays) {
  arrays[arrays["array"] = 0] = "array";
  arrays[arrays["contoare"] = 1] = "contoare";
  arrays[arrays["furnizori"] = 2] = "furnizori";
  arrays[arrays["servicii"] = 3] = "servicii";
  arrays[arrays["scari"] = 4] = "scari";
})(arrays || (arrays = {}));
/**
 * Accepted 'object's for a LodgerSchema field
 *
 * @enum {number}
 */


var objects;

(function (objects) {
  objects[objects["contactFields"] = 0] = "contactFields";
  objects[objects["object"] = 1] = "object";
  objects[objects["organizatie"] = 2] = "organizatie";
  objects[objects["$"] = 3] = "$";
  objects[objects["selApartamente"] = 4] = "selApartamente";
})(objects || (objects = {}));

var plurals = {
  apartament: 'apartamente',
  asociatie: 'asociatii',
  bloc: 'blocuri',
  contor: 'contoare',
  cheltuiala: 'cheltuieli',
  factura: 'facturi',
  furnizor: 'furnizori',
  incasare: 'incasari',
  serviciu: 'servicii',
  tranzactie: 'tranzactii',
  utilizator: 'utilizatori'
};
/**
 * Removes the '$' at the begining of a string
 *
 * @returns {String} the parsed string
 * @memberof String
 */

String.prototype.stripLeading = function (symbol) {
  if (this.indexOf(symbol) !== 0) return String(this);
  return String(this.replace(symbol, '').trim().stripLeading(symbol));
};

Object.defineProperties(String.prototype, {
  /**
   * Plurals. @todo use Intl
   */
  plural: {
    get: function () {
      return plurals[this] || String(this);
    }
  },

  /**
   * Converts a LodgerField type to RxDB compatible one
   *
   * Explicatie:
   * DB-ul nu stie decat de tipurile primare:
   * -> boolean, string, number, array, object
   * Schema noastra e mult mai detaliata
   *
   * @returns {string} - tipul primar, eg. 'string'
   */
  asRxDBType: {
    get: function () {
      var _default = 'string';

      var _this = this.toString();

      if (Object.keys(strings).indexOf(_this) > -1) return _default;
      if (Object.keys(objects).indexOf(_this) > -1) return 'object';
      if (Object.keys(numbers).indexOf(_this) > -1) return 'number';
      if (Object.keys(arrays).indexOf(_this) > -1) return 'array';
      return _default;
    }
  },

  /**
   * Splits a $ string into Money object
   *
   * @memberof String
   * @returns {Money}
   */
  asMoney: {
    get: function () {
      var split = this.split(' ');
      return {
        currency: split[0],
        amount: split[1]
      };
    }
  },

  /**
   * Slugifies a string
   *
   * @memberof String
   * @returns {String} the slug
   */
  slug: {
    get: function () {
      return this.toString().toLowerCase().replace(/\s+/g, '-') // Replace spaces with -
      .replace(/[^\w\-]+/g, '') // Remove all non-word chars
      .replace(/\-\-+/g, '-') // Replace multiple - with single -
      .replace(/^-+/, '') // Trim - from start of text
      .replace(/-+$/, ''); // Trim - from end of text
    }
  }
});
var S = {
  String: String
};

var currencies = [1,2,52,109,131,328,512,873,1027,1274,1437,1567,1759,2781,2782,2783,2784,2785,2786,2787,2788,2789,2790,2791,2792,2793,2794,2795,2796,2797,2798,2799,2800,2801,2802,2803,2804,2805,2806,2807,2808,2809,2810,2811,2812,2813,2814,2815,2816,2817,2818,2819,2820,2821,2822,2823,2824,2832,3526,3527,3528,3529,3530,3531,3532,3533,3534,3535,3536,3537,3538,3539,3540,3541,3542,3543,3544,3545,3546,3547,3548,3549,3550,3551,3552,3553,3554,3555,3556,3557,3558,3559,3560,3561,3562,3563,3564,3565,3566,3567,3568,3569,3570,3571,3572,3573];

var holder = {};
Object.defineProperties(holder, {
  $: {
    get: function () {
      return {
        moneda: "" + faker__default['default'].random.arrayElement(currencies),
        value: "" + faker__default['default'].finance.amount(100, 10000, 4)
      };
    }
  },
  id: {
    get: function () {
      return '...';
    }
  },
  string: {
    get: function () {
      return faker__default['default'].lorem.words(3);
    }
  },
  number: {
    get: function () {
      return Number(faker__default['default'].random.number({
        min: 0,
        max: 300
      }));
    }
  },
  fullName: {
    get: function () {
      return faker__default['default'].name.firstName() + " " + faker__default['default'].name.lastName();
    }
  },
  dateTime$: {
    get: function () {
      return Date.now() + faker__default['default'].random.number({
        min: 9000000,
        max: 100000000
      });
    }
  },
  buildingName: {
    get: function () {
      return faker__default['default'].random.alphaNumeric(2);
    }
  },
  serviceName: {
    get: function () {
      return faker__default['default'].hacker.adjective();
    }
  }
});

var String$1 = S.String;
/**
 *
 * @class Form Field Item
 * @implements {SchemaField}
 * @requires [String]
 * @extends RxJsonSchemaTopLevel
 */

var Field =
/** @class */
function () {
  /**
   * Creates an instance of Field.
   *
   * @param {FieldCreator<T>} data
   * @memberof Field
   */
  function Field(data) {
    var _this = this;

    this.type = 'string';
    this.storage = 'db'; // where to store data, in db or store

    this.value = function () {
      return _this.default || undefined;
    };

    this.key = 'index';

    if (!data) {
      // throw new FieldError('Field could not be created. No data supplied.')
      return;
    }

    var ref = data.ref,
        focus = data.focus,
        encrypted = data.encrypted,
        index = data.index,
        indexRef = data.indexRef,
        type = data.type,
        step = data.step,
        required = data.required,
        v = data.v,
        value = data.value,
        preview = data.preview,
        oninput = data.oninput,
        key = data.key,
        fieldset = data.fieldset,
        freezed = data.freezed,
        final = data.final,
        search = data.search,
        options = data.options;
    if (preview !== undefined) this.preview = preview;
    this._type = type; // hold this for reference

    this.type = String$1(type || '').asRxDBType;
    if (oninput) this.oninput = oninput;
    if (focus) this.focus = focus;
    if (options) this.options = options;
    if (final) this.final = final;
    if (key) this.key = key;
    if (key === 'attachments') this.type = undefined;
    if (search) this.search = search;
    if (index !== undefined) this._index = true;
    if (fieldset !== undefined) this.fieldset = fieldset;
    if (encrypted !== undefined) this.encrypted = encrypted; // transform the ref

    if (ref) {
      this.ref = ref;
      this.items = {
        type: 'string'
      };
      if (indexRef) this.index = indexRef;
    } // steps for numbers


    if (step !== undefined) {
      if (this.type !== 'number') throw new LodgerError('Type must be "number" for .step');
      this.multipleOf = step;
    } // hook in required to validation string


    if (required) {
      this.v = required && v && v.indexOf('required') < 0 ? v : "required|" + v;
    }

    if (freezed) this.freezed = true; // assign default value, can be undefined

    if (data.default !== undefined) this.default = data.default; // bind the value function

    var storage = this.storage;
    if (value && typeof value === 'function') this.value = value.bind({
      storage: storage
    });
    Object.defineProperty(this, 'fakeValue', {
      get: function () {
        return holder[type || 'string'];
      }
    });

    if (this._type === '$') {
      this.freezed = true;
      if (!this.default) this.default = function () {
        return {
          value: 0,
          moneda: this.displayCurrency
        };
      };
      this.items = {
        type: 'object',
        properties: {
          value: {
            type: 'number'
          },
          moneda: {
            type: 'number'
          }
        }
      };
    }
  }

  Object.defineProperty(Field.prototype, "label", {
    get: function () {
      var _this = this;

      return function (o) {
        var _a;

        if (o === void 0) {
          o = (_a = {}, _a[_this.key] = 'unnamed', _a);
        }

        try {
          return o[_this.key];
        } catch (e) {
          return 'undefined label';
        }
      };
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Field.prototype, "rxSchema", {
    /**
     * Used for Schema constructors,
     * returns only the properties needed for it
     */
    get: function () {
      var _this = this;

      var schema = {};
      var excludes = ['storage', 'value', 'v', 'default'];
      Object.keys(this).forEach(function (prop) {
        if (_this[prop] === undefined) return;
        if (excludes.indexOf(prop) > -1) return;
        schema[prop] = _this[prop];
      });
      return schema;
    },
    enumerable: false,
    configurable: true
  });

  __decorate([mobx.computed], Field.prototype, "label", null);

  return Field;
}();

var Errors$2;

(function (Errors) {
  Errors["missingProps"] = "Missing properties on schema %%";
  Errors["propExists"] = "Property \"%%\" already exists";
  Errors["idUndef"] = "ID for field %% cannot be undefined";
  Errors["invalidField"] = "Invalid field %% supplied";
})(Errors$2 || (Errors$2 = {}));
/**s
 *
 *
 * @class Schema
 * @extends {RxJsonSchema}
 * @implements {LodgerSchema}
 */


var Schema =
/** @class */
function () {
  /**
   * Constructs a valid RxJsonSchema out of a Lodger Form Data item
   *
   * @param {LodgerFormCreator} form
   * @param {boolean} [addCommonMethods]
   *
   * @memberof Schema
   * @returns {RxJsonSchema} schema
   */
  function Schema(name, fields, options) {
    var _this = this;

    this.name = name;
    this.type = 'object';
    this.version = 0;
    this.properties = {};
    this.required = [];
    this.indexes = [];
    if (!fields || !Object.keys(fields).length) throw new LodgerError(Errors$2.missingFields, {
      name: name
    });
    Object.keys(fields).map(function (f) {
      return _this.add(fields[f].id || f, fields[f]);
    });

    if (options) {
      if (options.attachments) {
        this.attachments = {
          encrypted: false
        };
      }
    }
  }
  /**
   * Adds properties programatically as
   * we also need to fill in the required array
   *
   * @param {FieldCreator} field
   * @memberof Schema
   */


  Schema.prototype.add = function (id, field) {
    if (!id) throw new LodgerError(Errors$2.idUndef, field);
    if (this.properties[id]) throw new LodgerError(Errors$2.propExists, id);
    if (field && !field.rxSchema) throw new LodgerError(Errors$2.invalidField, field);
    var rxSchema = field.rxSchema,
        v = field.v,
        storage = field.storage,
        _index = field._index,
        _type = field._type;
    if (storage !== 'db') return;
    var required = v && v.indexOf('required') > -1;
    this.properties[id] = rxSchema || {}; // this._fields[id] = field

    if (required && this.required.indexOf(id) < 0) this.required.push(id);

    if (_index) {
      this.indexes.push(_type !== '$' ? id : id + ".[].value");
    }
  };

  Object.defineProperty(Schema.prototype, "ids", {
    get: function () {
      return Object.keys(this.properties);
    },
    enumerable: false,
    configurable: true
  });
  return Schema;
}();

/**
 * Errors Definition
 * @readonly
 * @enum {string}
 *
 * @todo account for translations
 */

var Errors$1;

(function (Errors) {
  Errors["invalidRequested"] = "Invalid file requested: %%";
  Errors["invalidName"] = "Invalid name supplied: %%";
  Errors["missingFields"] = "Missing fields on form %%";
})(Errors$1 || (Errors$1 = {}));
/**
 * Lodder Form class
 *
 * @class Form
 * @implements {LodgerForm}
 */


var Form =
/** @class */
function () {
  /**
   * Creates an instance of Form.
   *
   * @param {LodgerFormCreator} data - Form input data
   * @param {boolean} [generateRxCollection=true] - some forms don't require this
   *
   * @memberof Form
   */
  function Form(data, opts) {
    var _this = this;

    this.opts = opts;
    this._onsubmit = []; // hooks

    this.fields = {};
    this.internalFields = {}; // readonly methods ?: {}

    this.$active = false;

    var _a = data || {
      name: 'untitled',
      fields: {}
    },
        fields = _a.fields,
        fieldsets = _a.fieldsets,
        name = _a.name;

    this.name = name;
    this.fields = {};
    this.internalFields = {};
    this.plural = this.name.plural;

    if (fields) {
      Object.keys(fields).map(function (key) {
        Object.assign(fields[key], {
          key: key
        });
        _this.fields[key] = new Field(fields[key]);
      });
    }

    if (fieldsets) {
      this.fieldsets = fieldsets;
    } // if (methods) {
    //   this.methods = methods
    // }


    if (opts) {
      var captureTimestamp = opts.captureTimestamp;

      if (captureTimestamp) {
        var timestampKeys = ['createdAt', 'updatedAt'];
        var captureTimestampField_1 = {
          type: 'dateTime',
          index: true
        };
        timestampKeys.map(function (key) {
          _this.fields[key] = new Field(__assign(__assign({}, captureTimestampField_1), {
            final: key === 'createdAt',
            freezed: key === 'updatedAt',
            default: function () {
              return new Date().getTime();
            }
          }));
        });
      }
    }

    this.schema = new Schema(name, this.fields, opts); // default onsubmit func

    this.onsubmit = function () {};
  }

  Object.defineProperty(Form.prototype, "fakeData", {
    // get _defaults () {
    //   const { fields, fieldsIds } = this
    //   return fieldsIds
    //     .concat(['state'])
    //     .map(function (b) {
    //       const field = fields[b]
    //       if (!field)
    //         return
    //       const def = field.default
    //       if (!def)
    //         return
    //       return def
    //     })
    // }

    /**
     * Fakes data for testing
     *
     * @readonly
     * @memberof Form
     */
    get: function () {
      var _a = this,
          fields = _a.fields,
          fieldsIds = _a.fieldsIds;

      return Object.fromEntries(fieldsIds.filter(function (fieldId) {
        return fieldId.indexOf('Id') < 0;
      }).map(function (fieldId) {
        var field = fields[fieldId]; // if (!field.default)
        //   return [fieldId, field.fakeValue]
        // try {
        //   const def = typeof field.default === 'function' ? field.default() : field.default
        //   return [fieldId, def]
        // } catch (e) {
        //   console.log('Using fake val and not default on', fieldId, 'because (missing context)', e)
        // }

        return [fieldId, field.fakeValue];
      }));
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Form.prototype, "data", {
    /**
     * Makes a Vue-ready $data {object} suitable to be completed
     * by the user in the frontend -> new form
     * (as it will turn reactive)
     *
     * @readonly
     * @memberof Form
     * @returns {Object}
     */
    get: function () {
      return Object.assign.apply(Object, __spreadArray([{}], Object.keys(this.fields)));
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Form.prototype, "fieldsIds", {
    /**
     * Quick access to all fields' ids
     *
     * @readonly
     * @memberof Form
     * @returns {string[]}
     */
    get: function () {
      return Object.keys(this.fields);
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Form.prototype, "previewFields", {
    get: function () {
      var _this = this;

      return this.fieldsIds.filter(function (field) {
        return _this.fields[field].preview > -1;
      }).sort(function (a, b) {
        return _this.fields[a].preview - _this.fields[b].preview;
      });
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Form.prototype, "refFields", {
    get: function () {
      var _this = this;

      return this.fieldsIds.filter(function (f) {
        return _this.schema.properties[f].ref !== undefined;
      });
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Form.prototype, "onsubmit", {
    /**
     * register a new onsubmit function
     *
     * @memberof Form
     */
    set: function (f) {
      this._onsubmit.push(f.bind(this));
    },
    enumerable: false,
    configurable: true
  });
  /**
   * Gets the value of current active form
   *
   * @summary for new forms, values are all undefined
   * @returns {Object} data item (Vue $data - ready)
   */

  Form.prototype.value = function (context) {
    var _this = this;

    var $data = {};
    this.fieldsIds.forEach(function (fieldId) {
      var field = _this.fields[fieldId];
      if (field.storage !== 'db') return; // todo: pune din store

      $data[fieldId] = field.value(context);
    });
    return $data;
  };

  return Form;
}();

/**
 * Notifies the user and also us, the devs, of anything!
 *
 * @kind Store action wrapper
 * fallsback to console
 *
 * @param {Notification} notification
 */

function notify(notification) {
  /**
   * if/when bound to Store
   * to be used on frontend mostly
   *
   */
  if (this && typeof this.dispatch === 'function' && this.actions.notify) {
    this.dispatch('notify', notification);
    return;
  } // Fallback -> Consola


  var type = notification.type,
      text = notification.text;
  consola__default['default'][type](text); // Always throw the err for stack reporting

  if (type === 'error') throw new Error(text);
}

var counters$1 = (function (collectionName) {
  return {
    inc: function (data) {
      return data.state.counters[collectionName] += 1, data;
    },
    dec: function (data) {
      return data.state.counters[collectionName] -= 1, data;
    }
  };
});

var counterUpdates = function (_a) {
  var incDec = _a.incDec,
      taxes = _a.taxes,
      data = _a.data,
      $taxonomies = _a.$taxonomies,
      plural = _a.plural;

  var _b = counters$1(plural),
      inc = _b.inc,
      dec = _b.dec;

  return taxes.map(function (tax) {
    return __awaiter(void 0, void 0, void 0, function () {
      var id, isMultiple, collection, parentDocs, _a;

      return __generator(this, function (_b) {
        switch (_b.label) {
          case 0:
            id = data[tax + "Id"] || data[tax];
            if (!id) throw new Error("Missing taxes ids to update counters " + {
              taxes: taxes,
              data: data
            });
            isMultiple = typeof id === 'object' && id.length >= 1;
            collection = $taxonomies[tax.plural].collection;
            if (!isMultiple) return [3
            /*break*/
            , 2];
            return [4
            /*yield*/
            , collection.findByIds(id)];

          case 1:
            _a = _b.sent();
            return [3
            /*break*/
            , 4];

          case 2:
            return [4
            /*yield*/
            , collection.findOne(id).exec()];

          case 3:
            _a = _b.sent();
            _b.label = 4;

          case 4:
            parentDocs = _a;
            if (!parentDocs) throw new Error("Missing parent(s) doc(s): " + (tax));
            if (!isMultiple) return [3
            /*break*/
            , 7];
            if (!parentDocs.size) return [3
            /*break*/
            , 6];
            return [4
            /*yield*/
            , Promise.all(id.map(function (_id) {
              return __awaiter(void 0, void 0, void 0, function () {
                var _doc;

                return __generator(this, function (_a) {
                  switch (_a.label) {
                    case 0:
                      _doc = parentDocs.get(_id);
                      return [4
                      /*yield*/
                      , _doc.atomicUpdate(incDec ? inc : dec)];

                    case 1:
                      _a.sent();

                      return [2
                      /*return*/
                      ];
                  }
                });
              });
            }))];

          case 5:
            _b.sent();

            _b.label = 6;

          case 6:
            return [3
            /*break*/
            , 9];

          case 7:
            return [4
            /*yield*/
            , parentDocs.atomicUpdate(incDec ? inc : dec)];

          case 8:
            _b.sent();

            _b.label = 9;

          case 9:
            return [2
            /*return*/
            ];
        }
      });
    });
  });
};

var parentsState = {
  counters: function (hookName) {
    var _this = this;

    var _a = this,
        parents = _a.parents,
        $taxonomies = _a.$lodger.$taxonomies,
        plural = _a.plural;

    var incDec = hookName !== 'Remove';
    return function (data, $doc) {
      return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
          switch (_a.label) {
            case 0:
              if (hookName === 'Save' && !$doc._isTemporary) return [2
              /*return*/
              ];
              return [4
              /*yield*/
              , Promise.all(counterUpdates({
                incDec: incDec,
                taxes: parents,
                data: data,
                plural: plural,
                $taxonomies: $taxonomies
              }))];

            case 1:
              _a.sent();

              return [2
              /*return*/
              ];
          }
        });
      });
    };
  }
};

var counters = parentsState.counters;
var Errors;

(function (Errors) {
  Errors["noDB"] = "Please setup a DB first!";
})(Errors || (Errors = {}));

var db;
var generalHooks = ['Save', 'Insert', 'Remove'];
/**
 * @class Taxonomy
 * @implements {LodgerTaxonomy}
 *
 * @requires Form
 *
 * @param {Taxonomie} name - name of the form
 * @param {Form} form - the constructed form item
 */

var Taxonomy =
/** @class */
function () {
  /**
   * Creates an instance of Taxonomy.
   *
   * @param {Form<T, Interface>} form
   * @param {RxCollection<Interface>} collection
   * @memberof Taxonomy
   */
  function Taxonomy(_schema, options) {
    if (options === void 0) {
      options = {
        timestamps: true
      };
    }

    this._schema = _schema;
    this.options = options;
    this.lastItems = [];
    var name = _schema.name,
        fields = _schema.fields,
        fieldsets = _schema.fieldsets,
        hooks = _schema.hooks;
    var timestamps = options.timestamps,
        attachments = options.attachments;
    this.form = new Form({
      name: name,
      fields: fields,
      fieldsets: fieldsets,
      hooks: hooks
    }, {
      captureTimestamp: timestamps,
      attachments: attachments
    });
  }

  Object.defineProperty(Taxonomy.prototype, "last", {
    /**
     * Last added item's id
     *
     * @readonly
     * @memberof Taxonomy
     */
    get: function () {
      return this.lastItems[0];
    },
    set: function (id) {
      if (id) this.lastItems.unshift(id);else this.lastItems.shift();
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Taxonomy, "db", {
    /**
     * DB handler
     *
     * @static
     * @memberof Taxonomy
     */
    set: function (xdb) {
      db = xdb;
    },
    enumerable: false,
    configurable: true
  });
  /**
   * @alias db.destroy
   *
   * @static
   * @memberof Taxonomy
   */

  Taxonomy.destroy = function () {
    return __awaiter(this, void 0, void 0, function () {
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            if (!db) return [2
            /*return*/
            ];
            return [4
            /*yield*/
            , db.destroy()];

          case 1:
            _a.sent();

            return [2
            /*return*/
            ];
        }
      });
    });
  };

  Object.defineProperty(Taxonomy.prototype, "name", {
    /**
     * Taxonomy name, singular
     *
     * @readonly
     * @memberof Taxonomy
     */
    get: function () {
      return this.form.schema.name;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Taxonomy.prototype, "plural", {
    get: function () {
      return this.form.plural;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Taxonomy.prototype, "refTaxes", {
    get: function () {
      return this.form.refFields.map(function (f) {
        return f.replace('Id', '').plural;
      });
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Taxonomy.prototype, "_collectionCreator", {
    get: function () {
      var _a = this._schema,
          name = _a.name,
          methods = _a.methods,
          statics = _a.statics;
      var schema = this.form.schema;
      return {
        name: name,
        schema: schema,
        methods: methods,
        statics: statics
      };
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Taxonomy.prototype, "collection", {
    get: function () {
      return this.$collection;
    },
    set: function (collection) {
      var _this = this;

      var _a = this,
          _b = _a._schema,
          hooks = _b.hooks,
          methods = _b.methods,
          timestamps = _a.options.timestamps,
          internalFields = _a.form.internalFields,
          freshDates = _a.$lodger.freshDates,
          $collection = _a.$collection,
          children = _a.children,
          parents = _a.parents;

      if ($collection) throw new Error("Collection already set for " + plurral + " taxonomy");

      var emitDBupdated = function () {
        _this.$lodger.emit('dbUpdated');
      };

      var updateParentsStateCounters = counters.bind(this);

      var assignFreshDates = function (data) {
        return __awaiter(_this, void 0, void 0, function () {
          var dates;
          return __generator(this, function (_a) {
            if (!timestamps) return [2
            /*return*/
            ];
            dates = freshDates();
            Object.assign(data, !data.updatedAt ? dates : {
              updatedAt: dates.updatedAt
            });
            return [2
            /*return*/
            , data];
          });
        });
      };

      var setLastDocument = function (updRmv) {
        return function (data, doc) {
          _this.last = updRmv ? doc._id : undefined;
        };
      };

      var putInternalFieldsIfMissing = function (data) {
        if (!children || !children.length || data.state) return;
        Object.assign(data, Object.keys(internalFields).reduce(function (a, b) {
          var _a;

          return __assign(__assign({}, a), (_a = {}, _a[b] = internalFields[b].default, _a));
        }, {}));
        return data;
      };

      generalHooks.filter(function (h) {
        return h !== 'Remove';
      }).map(function (hName) {
        var preHook = "pre" + hName; // const postHook = `post${ hName }`

        collection[preHook](assignFreshDates, false);
        collection[preHook](putInternalFieldsIfMissing, false);
      });
      generalHooks.map(function (hookName) {
        var hook = "post" + hookName;
        collection[hook](setLastDocument(hookName !== 'Remove'), true);
        collection[hook](emitDBupdated, true);
        if (parents && parents.length) collection[hook](updateParentsStateCounters(hookName), false);
      }); // Schema hooks. Individual for each taxonomy

      if (hooks) {
        Object.keys(hooks).forEach(function (hook) {
          if (['empty'].indexOf(hook) > -1) return;
          hooks[hook] = hooks[hook](_this.$lodger);
          collection[hook](hooks[hook]);
        });
      }

      if (methods) {
        Object.keys(methods).forEach(function (method) {
          _this[method] = methods[method].bind(_this.$lodger);
        });
      } // this.form.fieldsIds
      //   .filter(fieldId => this.form.fields[fieldId].search)
      //   .forEach(fieldId => collection.searchFields.push(fieldId))


      this.$collection = collection;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Taxonomy.prototype, "sortOptions", {
    /**
     * Relationship between taxonomies
     *
     * @readonly
     * @memberof Taxonomy
     */
    // get refs () {
    //   const { $lodger, form: { fields, fieldsIds } } = this
    //   if (!$lodger)
    //     return {}
    //   return fieldsIds
    //     .filter(id => fields[id].ref)
    //     .map(id => ({
    //       [id]: fields[id].ref
    //     }))
    // }
    get: function () {
      var _a = this,
          $lodger = _a.$lodger,
          _b = _a.form,
          fields = _b.fields,
          indexes = _b.schema.indexes,
          name = _a.name;

      var i18n = $lodger.i18n;
      return Object.assign.apply(Object, __spreadArray([{}], indexes.map(function (n) {
        var _a, _b;

        var parsedN = n.replace('.[].', '_');
        var simplifiedN = parsedN.split('_')[0];

        var _18n = i18n.taxonomies[name.plural].fields[simplifiedN] || i18n.sort.fields[simplifiedN] || parsedN;

        var field = fields[simplifiedN];
        var type = field.type;
        var showOrds = type === 'string' ? ['AZ', 'ZA'] : type === 'number' ? ['09', '90'] : ['asc', 'desc'];
        return _a = {}, _a[_18n] = (_b = {}, _b[parsedN + "-asc"] = showOrds[0], _b[parsedN + "-desc"] = showOrds[1], _b), _a;
      })));
    },
    enumerable: false,
    configurable: true
  });
  /**
   * * Removes a Document by ID from the collection
   *
   * @param {string} id
   * @returns {RxDocument<T>} removed document
   * @memberof Taxonomy
   */

  Taxonomy.prototype.trash = function (id) {
    return __awaiter(this, void 0, void 0, function () {
      var e_1;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            _a.trys.push([0, 2,, 3]);

            return [4
            /*yield*/
            , this.collection.findOne(id).remove()];

          case 1:
            _a.sent();

            if (this.last === id) this.last = undefined;
            return [3
            /*break*/
            , 3];

          case 2:
            e_1 = _a.sent();
            notify({
              type: 'error',
              text: e_1
            });
            return [3
            /*break*/
            , 3];

          case 3:
            return [2
            /*return*/
            ];
        }
      });
    });
  };
  /**
   * * Inserts/upserts a new item in DB
   *
   * @param {Object} doc
   * @returns {RxDocument<Taxonomie>} the fresh document
   *
   * @memberof Taxonomy
   */


  Taxonomy.prototype.put = function (doc) {
    return __awaiter(this, void 0, void 0, function () {
      var method, _doc, id, e_2;

      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            if (!doc || Object.keys(doc).length < 1) throw new LodgerError('Invalid doc supplied %%', {
              doc: doc
            });
            method = doc._id ? 'upsert' : 'insert';
            _a.label = 1;

          case 1:
            _a.trys.push([1, 3,, 4]);

            return [4
            /*yield*/
            , this.collection[method](doc)];

          case 2:
            _doc = _a.sent();
            id = _doc._id;
            notify({
              type: 'success',
              text: "[" + method + "] " + this.name + "!" + (['dev', 'test'].indexOf(process.env.NODE_ENV) > -1 ? "(" + id + ")" : '')
            });
            return [2
            /*return*/
            , _doc];

          case 3:
            e_2 = _a.sent();
            notify({
              type: 'error',
              text: String(e_2)
            });
            return [3
            /*break*/
            , 4];

          case 4:
            return [2
            /*return*/
            ];
        }
      });
    });
  };

  Object.defineProperty(Taxonomy.prototype, "config", {
    /**
     * @readonly
     * @memberof Taxonomy
     * Taxonomy default config
     */
    get: function () {
      var taxonomii = config.taxonomii;
      var defaults = taxonomii.defaults;
      return taxonomii[this.name] || defaults;
    },
    enumerable: false,
    configurable: true
  });

  __decorate([mobx.observable], Taxonomy.prototype, "lastItems", void 0);

  __decorate([mobx.computed], Taxonomy.prototype, "last", null);

  __decorate([mobx.computed], Taxonomy.prototype, "sortOptions", null);

  return Taxonomy;
}();

var overwriteMerge = function (destinationArray, sourceArray, options) {
  return sourceArray;
};

var STaxonomy =
/** @class */
function (_super) {
  __extends(STaxonomy, _super);

  function STaxonomy() {
    var _this = _super.apply(this, arguments) || this;

    _this.subscribers = {};
    _this._refsIds = {};
    return _this;
  }

  STaxonomy.init = function () {
    return _super.init.apply(this, arguments);
  };

  Object.defineProperty(STaxonomy.prototype, "data", {
    /**
     * Returns all data from subscribers
     *
     * @readonly
     * @memberof Taxonomy
     */
    get: function () {
      var _this = this;

      return Object.keys(this.subscribers).reduce(function (a, b) {
        return __assign(__assign({}, a), _this.subscribers[b].items);
      }, {});
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(STaxonomy.prototype, "dataIds", {
    get: function () {
      return Object.keys(this.data);
    },
    enumerable: false,
    configurable: true
  });

  STaxonomy.prototype.getDocument = function (id) {
    var _a;

    return __awaiter(this, void 0, void 0, function () {
      var _b;

      return __generator(this, function (_c) {
        switch (_c.label) {
          case 0:
            if (typeof id === 'object' && id.length === 1) id = id[0];
            _c.label = 1;

          case 1:
            _c.trys.push([1, 5,, 6]);

            if (!(this.dataIds.indexOf(id) > -1)) return [3
            /*break*/
            , 2];
            _b = this.data[id]._doc;
            return [3
            /*break*/
            , 4];

          case 2:
            return [4
            /*yield*/
            , (_a = this.$collection) === null || _a === void 0 ? void 0 : _a.findOne(id).exec()];

          case 3:
            _b = _c.sent();
            _c.label = 4;

          case 4:
            return [2
            /*return*/
            , _b];

          case 5:
            _c.sent();
            console.error('could not get document', id, this.plural);
            return [3
            /*break*/
            , 6];

          case 6:
            return [2
            /*return*/
            ];
        }
      });
    });
  };

  Object.defineProperty(STaxonomy.prototype, "refsIds", {
    get: function () {
      return this._refsIds;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(STaxonomy.prototype, "subscribed", {
    /**
     * @readonly
     * @memberof Taxonomy
     * @returns {Boolean} if subscribed anywhere
     */
    get: function () {
      return Object.keys(this.subscribers).length > 0;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(STaxonomy.prototype, "defaultCriteria", {
    get: function () {
      return _super.prototype.config.criteriu;
    },
    enumerable: false,
    configurable: true
  });
  /**
   * Subscribes.
   *
   * @param {string} [subscriberName='main']
   * @param {Criteriu} [criteriuCerut]
   * @returns {Promise<Subscriber<T>>} the unwatcher for subscriber
   * @memberof Taxonomy
   */

  STaxonomy.prototype.subscribe = function (subscriberName, options) {
    if (subscriberName === void 0) {
      subscriberName = 'main';
    }

    return __awaiter(this, void 0, void 0, function () {
      var _a, hooks, subscribers, plural, _b, state, modal, taxonomies, $taxonomies, descriptor, subState, sub, allTaxes, updateTaxes;

      var _c;

      var _this = this;

      return __generator(this, function (_d) {
        switch (_d.label) {
          case 0:
            _a = this, hooks = _a.hooks, subscribers = _a.subscribers, plural = _a.plural, _b = _a.$lodger, state = _b.state, modal = _b.modal, taxonomies = _b.taxonomies, $taxonomies = _b.$taxonomies, _b.mainSubName;
            if (subscribers[subscriberName]) return [2
            /*return*/
            ];
            descriptor = subscriberName + "-" + taxonomies.indexOf(plural);
            subState = state.subs[descriptor] || Object.assign(state.subs, (_c = {}, _c[descriptor] = {}, _c)) && state.subs[descriptor];
            sub = this.subscribers[subscriberName] = new Subscriber__default['default'](this.collection, merge__default['default'](options, subState));

            if (this.parents && this.parents.length && !sub.refsIds) {
              sub.refsIds = mobx.observable({});
            }

            allTaxes = [];

            updateTaxes = function (taxes, id, name) {
              if (!taxes || !taxes.length) return;
              if (!allTaxes.length) allTaxes = __spreadArray([], taxonomies);
              taxes.forEach(function (tax) {
                var _a, _b;

                var $tax = $taxonomies[tax] || $taxonomies[tax.plural];
                if (!$tax) return true;

                if (allTaxes && allTaxes.length && allTaxes.indexOf(tax.plural) > -1) {
                  allTaxes.splice(allTaxes.indexOf(tax.plural), 1);
                } else {
                  return true;
                }

                var subName = subscriberName.indexOf('prince') < 0 ? subscriberName.split('-')[0] + "-" + tax.plural : subscriberName;
                var subscribers = $tax.subscribers,
                    parents = $tax.parents;
                    $tax.children;
                var taxSub = subscribers[subName];

                if (!taxSub) {
                  console.error('Invalid subscriber requested', subName, tax);
                  console.error('orig subscriberName', subscriberName);
                  return;
                }

                var sOrP, op, val; // deselect selected items of children

                if (taxSub.selectedId) taxSub.select(taxSub.selectedId); // select parents if differ
                // if ($tax.parents && tax.parents.length) {
                // }

                if (taxSub.refsIds) {
                  if (parents && parents.length && (parents.indexOf(name) > -1 || parents.indexOf(name.plural) > -1)) {
                    var isSingular = parents.indexOf(name) > -1;
                    sOrP = isSingular ? name + "Id" : _this.form.plural;
                    op = isSingular ? '$eq' : '$in';
                    val = isSingular ? id : [id];
                    taxSub.refsIds[sOrP] = val;
                  }
                }

                if (sOrP && op && val) {
                  var filter = (_a = {}, _a[sOrP] = (_b = {}, _b[op] = val, _b), _a);
                  console.info('Settting filters on ', tax, subscriberName, filter);
                  taxSub.criteria.filter = merge__default['default'](taxSub.criteria.filter, filter, {
                    arrayMerge: overwriteMerge
                  });
                } else {
                  if (taxSub.criteria.filter) {
                    try {
                      console.info('Deleting filter', sOrP, 'on', tax, subscriberName); // An ugly implementantion, mobx and even deepobserve, dont react on delete

                      taxSub.criteria.filter = __assign({}, Object.keys(taxSub.criteria.filter).filter(function (k) {
                        return k !== sOrP;
                      }).reduce(function (a, b) {
                        var _a;

                        return __assign(__assign({}, a), (_a = {}, _a[b] = taxSub.criteria.filter[b], _a));
                      }, {}));
                    } catch (e) {
                      console.error('Could not delete filter', sOrP, 'on', tax, e);
                    }

                    if (Object.keys(taxSub.criteria.filter).length === 0) {
                      console.info('Settting filter to NULL on', descriptor, Object.keys(taxSub.criteria.filter));
                      taxSub.criteria.filter = null;
                    }
                  }
                }
              });
              console.info(plural, 'tax updated! ->', taxes);
            };

            if (!hooks) return [3
            /*break*/
            , 2];
            if (!hooks.empty) return [3
            /*break*/
            , 2];
            return [4
            /*yield*/
            , sub.updates];

          case 1:
            _d.sent();

            if (!sub.ids.length) hooks.empty.call(this);
            _d.label = 2;

          case 2:
            mobx.reaction(function () {
              return sub.selectedId;
            }, function (id) {
              Object.assign(subState, {
                selectedId: id
              }); // if (subscriberName === 'single')
              //   return

              allTaxes = []; // has to be reset every time !

              updateTaxes(_this.children, id, _this.name);
            });
            mobx.reaction(function () {
              return __assign({}, sub.criteria);
            }, function (criteria, prevCriteria) {
              console.info(_this.name, 'Criteria changed', criteria, prevCriteria);
              Object.assign(subState, {
                criteria: JSON.parse(JSON.stringify(criteria))
              });
            }); // Trigger the modal on activeId change

            if (subscriberName.indexOf('single') < 0) {
              mobx.reaction(function () {
                return sub.activeId;
              }, function (id) {
                return __awaiter(_this, void 0, void 0, function () {
                  var activeDoc;
                  return __generator(this, function (_a) {
                    switch (_a.label) {
                      case 0:
                        Object.assign(subState, {
                          activeId: id
                        });
                        if (!id) return [2
                        /*return*/
                        ];
                        return [4
                        /*yield*/
                        , this.collection.findOne(id).exec()];

                      case 1:
                        activeDoc = _a.sent();
                        modal.activeDoc = activeDoc;
                        Object.assign(modal, {
                          sub: sub
                        });
                        return [2
                        /*return*/
                        ];
                    }
                  });
                });
              });
            }

            return [2
            /*return*/
            ];
        }
      });
    });
  };
  /**
   *
   *
   * @param {string} [subscriberName='main']
   * @memberof STaxonomy
   */


  STaxonomy.prototype.unsubscribe = function (subscriberName) {
    if (subscriberName === void 0) {
      subscriberName = 'main';
    }

    var subscriber = this.subscribers[subscriberName];

    try {
      if (subscriber.kill) subscriber.kill();
    } catch (e) {}

    delete this.subscribers[subscriberName];
  };
  /**
   * Kills all active listeners for a given subscriber name
   *
   * @returns {Promise}
   * @memberof Taxonomy
   */


  STaxonomy.prototype.unsubscribeAll = function () {
    var _this = this;

    var subscribers = this.subscribers;
    if (!subscribers || !Object.keys(subscribers).length) throw new LodgerError('no subs');
    Object.keys(subscribers).forEach(function (s) {
      _this.unsubscribe(s);
    });
  };

  Object.defineProperty(STaxonomy.prototype, "hooks", {
    // referencesIds (subName: string) {
    //   const sub = this.subscribers[subName]
    //   if (!sub)
    //     throw new LodgerError('Invalid subscriber requested for refsIds')
    //   const { parents } = this
    //   if (!parents) return
    //   // const x = {}
    //   parents.map(tax => {
    //     const $tax = this.$lodger[tax] || this.$lodger[tax.plural]
    //     if (!$tax) return
    //     const { form: { plural }, subscribers } = $tax
    //     const taxSub = subscribers[subName]
    //     if (taxSub) {
    //       const { selectedId } = taxSub
    //       if (selectedId)
    //         this.refsIds[subName][plural === tax ? plural : `${tax}Id`] = plural === tax ? [ selectedId ] : selectedId
    //     }
    //   })
    //   // return x
    // }
    get: function () {
      return this._schema.hooks;
    },
    enumerable: false,
    configurable: true
  });

  __decorate([mobx.observable], STaxonomy.prototype, "subscribers", void 0);

  __decorate([mobx.observable], STaxonomy.prototype, "_refsIds", void 0);

  __decorate([mobx.computed], STaxonomy.prototype, "data", null);

  __decorate([mobx.computed], STaxonomy.prototype, "dataIds", null);

  __decorate([mobx.computed], STaxonomy.prototype, "refsIds", null);

  return STaxonomy;
}(Taxonomy);

var dynamicTargets = {
  'Apartament.ts': () => Promise.resolve().then(function () { return Apartament; }),
  'Asociatie.ts': () => Promise.resolve().then(function () { return Asociatie; }),
  'Bloc.ts': () => Promise.resolve().then(function () { return Bloc; }),
  'Cheltuiala.ts': () => Promise.resolve().then(function () { return Cheltuiala; }),
  'Contor.ts': () => Promise.resolve().then(function () { return Contor; }),
  'Factura.ts': () => Promise.resolve().then(function () { return Factura; }),
  'Feedback.ts': () => Promise.resolve().then(function () { return Feedback; }),
  'Furnizor.ts': () => Promise.resolve().then(function () { return Furnizor; }),
  'Incasare.ts': () => Promise.resolve().then(function () { return Incasare; }),
  'Serviciu.ts': () => Promise.resolve().then(function () { return Serviciu; }),
  'Tranzactie.ts': () => Promise.resolve().then(function () { return Tranzactie; }),
  'Utilizator.ts': () => Promise.resolve().then(function () { return Utilizator; })
};

/**
 * Rollup helper file
 * to dynamically load schemas based on filename
 */

var capitalize = function (s) {
  if (typeof s !== 'string') return '';
  return s.charAt(0).toUpperCase() + s.slice(1);
};

function load(schemas) {
  return __awaiter(this, void 0, void 0, function () {
    var _this = this;

    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          return [4
          /*yield*/
          , Promise.all(schemas.map(function (schemaFileName) {
            return __awaiter(_this, void 0, void 0, function () {
              var fileName, schema, _a;

              return __generator(this, function (_b) {
                switch (_b.label) {
                  case 0:
                    fileName = capitalize(schemaFileName) + ".ts";
                    _a = [{}];
                    return [4
                    /*yield*/
                    , dynamicTargets[fileName]()];

                  case 1:
                    schema = __assign.apply(void 0, _a.concat([_b.sent()]));
                    Object.defineProperty(schema, 'name', {
                      writable: false,
                      value: String(fileName.split('.')[0]).toLowerCase()
                    });
                    return [2
                    /*return*/
                    , schema];
                }
              });
            });
          }))];

        case 1:
          return [2
          /*return*/
          , _a.sent()];
      }
    });
  });
}

var currencyList = {"fiat":{"2781":{"name":"United States Dollar","sign":"$","symbol":"USD"},"2782":{"name":"Australian Dollar","sign":"$","symbol":"AUD"},"2783":{"name":"Brazilian Real","sign":"R$","symbol":"BRL"},"2784":{"name":"Canadian Dollar","sign":"$","symbol":"CAD"},"2785":{"name":"Swiss Franc","sign":"Fr","symbol":"CHF"},"2786":{"name":"Chilean Peso","sign":"$","symbol":"CLP"},"2787":{"name":"Chinese Yuan","sign":"¥","symbol":"CNY"},"2788":{"name":"Czech Koruna","sign":"Kč","symbol":"CZK"},"2789":{"name":"Danish Krone","sign":"kr","symbol":"DKK"},"2790":{"name":"Euro","sign":"€","symbol":"EUR"},"2791":{"name":"Pound Sterling","sign":"£","symbol":"GBP"},"2792":{"name":"Hong Kong Dollar","sign":"$","symbol":"HKD"},"2793":{"name":"Hungarian Forint","sign":"Ft","symbol":"HUF"},"2794":{"name":"Indonesian Rupiah","sign":"Rp","symbol":"IDR"},"2795":{"name":"Israeli New Shekel","sign":"₪","symbol":"ILS"},"2796":{"name":"Indian Rupee","sign":"₹","symbol":"INR"},"2797":{"name":"Japanese Yen","sign":"¥","symbol":"JPY"},"2798":{"name":"South Korean Won","sign":"₩","symbol":"KRW"},"2799":{"name":"Mexican Peso","sign":"$","symbol":"MXN"},"2800":{"name":"Malaysian Ringgit","sign":"RM","symbol":"MYR"},"2801":{"name":"Norwegian Krone","sign":"kr","symbol":"NOK"},"2802":{"name":"New Zealand Dollar","sign":"$","symbol":"NZD"},"2803":{"name":"Philippine Peso","sign":"₱","symbol":"PHP"},"2804":{"name":"Pakistani Rupee","sign":"₨","symbol":"PKR"},"2805":{"name":"Polish Złoty","sign":"zł","symbol":"PLN"},"2806":{"name":"Russian Ruble","sign":"₽","symbol":"RUB"},"2807":{"name":"Swedish Krona","sign":"kr","symbol":"SEK"},"2808":{"name":"Singapore Dollar","sign":"S$","symbol":"SGD"},"2809":{"name":"Thai Baht","sign":"฿","symbol":"THB"},"2810":{"name":"Turkish Lira","sign":"₺","symbol":"TRY"},"2811":{"name":"New Taiwan Dollar","sign":"NT$","symbol":"TWD"},"2812":{"name":"South African Rand","sign":"R","symbol":"ZAR"},"2813":{"name":"United Arab Emirates Dirham","sign":"د.إ","symbol":"AED"},"2814":{"name":"Bulgarian Lev","sign":"лв","symbol":"BGN"},"2815":{"name":"Croatian Kuna","sign":"kn","symbol":"HRK"},"2816":{"name":"Mauritian Rupee","sign":"₨","symbol":"MUR"},"2817":{"name":"Romanian Leu","sign":"lei","symbol":"RON"},"2818":{"name":"Icelandic Króna","sign":"kr","symbol":"ISK"},"2819":{"name":"Nigerian Naira","sign":"₦","symbol":"NGN"},"2820":{"name":"Colombian Peso","sign":"$","symbol":"COP"},"2821":{"name":"Argentine Peso","sign":"$","symbol":"ARS"},"2822":{"name":"Peruvian Sol","sign":"S/.","symbol":"PEN"},"2823":{"name":"Vietnamese Dong","sign":"₫","symbol":"VND"},"2824":{"name":"Ukrainian Hryvnia","sign":"₴","symbol":"UAH"},"2832":{"name":"Bolivian Boliviano","sign":"Bs.","symbol":"BOB"},"3526":{"name":"Albanian Lek","sign":"L","symbol":"ALL"},"3527":{"name":"Armenian Dram","sign":"֏","symbol":"AMD"},"3528":{"name":"Azerbaijani Manat","sign":"₼","symbol":"AZN"},"3529":{"name":"Bosnia-Herzegovina Convertible Mark","sign":"KM","symbol":"BAM"},"3530":{"name":"Bangladeshi Taka","sign":"৳","symbol":"BDT"},"3531":{"name":"Bahraini Dinar","sign":".د.ب","symbol":"BHD"},"3532":{"name":"Bermudan Dollar","sign":"$","symbol":"BMD"},"3533":{"name":"Belarusian Ruble","sign":"Br","symbol":"BYN"},"3534":{"name":"Costa Rican Colón","sign":"₡","symbol":"CRC"},"3535":{"name":"Cuban Peso","sign":"$","symbol":"CUP"},"3536":{"name":"Dominican Peso","sign":"$","symbol":"DOP"},"3537":{"name":"Algerian Dinar","sign":"د.ج","symbol":"DZD"},"3538":{"name":"Egyptian Pound","sign":"£","symbol":"EGP"},"3539":{"name":"Georgian Lari","sign":"₾","symbol":"GEL"},"3540":{"name":"Ghanaian Cedi","sign":"₵","symbol":"GHS"},"3541":{"name":"Guatemalan Quetzal","sign":"Q","symbol":"GTQ"},"3542":{"name":"Honduran Lempira","sign":"L","symbol":"HNL"},"3543":{"name":"Iraqi Dinar","sign":"ع.د","symbol":"IQD"},"3544":{"name":"Iranian Rial","sign":"﷼","symbol":"IRR"},"3545":{"name":"Jamaican Dollar","sign":"$","symbol":"JMD"},"3546":{"name":"Jordanian Dinar","sign":"د.ا","symbol":"JOD"},"3547":{"name":"Kenyan Shilling","sign":"Sh","symbol":"KES"},"3548":{"name":"Kyrgystani Som","sign":"с","symbol":"KGS"},"3549":{"name":"Cambodian Riel","sign":"៛","symbol":"KHR"},"3550":{"name":"Kuwaiti Dinar","sign":"د.ك","symbol":"KWD"},"3551":{"name":"Kazakhstani Tenge","sign":"₸","symbol":"KZT"},"3552":{"name":"Lebanese Pound","sign":"ل.ل","symbol":"LBP"},"3553":{"name":"Sri Lankan Rupee","sign":"Rs","symbol":"LKR"},"3554":{"name":"Moroccan Dirham","sign":"د.م.","symbol":"MAD"},"3555":{"name":"Moldovan Leu","sign":"L","symbol":"MDL"},"3556":{"name":"Macedonian Denar","sign":"ден","symbol":"MKD"},"3557":{"name":"Myanma Kyat","sign":"Ks","symbol":"MMK"},"3558":{"name":"Mongolian Tugrik","sign":"₮","symbol":"MNT"},"3559":{"name":"Namibian Dollar","sign":"$","symbol":"NAD"},"3560":{"name":"Nicaraguan Córdoba","sign":"C$","symbol":"NIO"},"3561":{"name":"Nepalese Rupee","sign":"₨","symbol":"NPR"},"3562":{"name":"Omani Rial","sign":"ر.ع.","symbol":"OMR"},"3563":{"name":"Panamanian Balboa","sign":"B/.","symbol":"PAB"},"3564":{"name":"Qatari Rial","sign":"ر.ق","symbol":"QAR"},"3565":{"name":"Serbian Dinar","sign":"дин.","symbol":"RSD"},"3566":{"name":"Saudi Riyal","sign":"ر.س","symbol":"SAR"},"3567":{"name":"South Sudanese Pound","sign":"£","symbol":"SSP"},"3568":{"name":"Tunisian Dinar","sign":"د.ت","symbol":"TND"},"3569":{"name":"Trinidad and Tobago Dollar","sign":"$","symbol":"TTD"},"3570":{"name":"Ugandan Shilling","sign":"Sh","symbol":"UGX"},"3571":{"name":"Uruguayan Peso","sign":"$","symbol":"UYU"},"3572":{"name":"Uzbekistan Som","sign":"so'm","symbol":"UZS"},"3573":{"name":"Sovereign Bolivar","sign":"Bs.","symbol":"VES"}},"cryptocurrency":{"1":{"name":"Bitcoin","symbol":"BTC"},"2":{"name":"Litecoin","symbol":"LTC"},"52":{"name":"XRP","symbol":"XRP"},"109":{"name":"DigiByte","symbol":"DGB"},"131":{"name":"Dash","symbol":"DASH"},"328":{"name":"Monero","symbol":"XMR"},"512":{"name":"Stellar","symbol":"XLM"},"873":{"name":"NEM","symbol":"XEM"},"1027":{"name":"Ethereum","symbol":"ETH"},"1274":{"name":"Waves","symbol":"WAVES"},"1437":{"name":"Zcash","symbol":"ZEC"},"1567":{"name":"Nano","symbol":"NANO"},"1759":{"name":"Status","symbol":"SNT"}}};

var rates = {"data":{"1":57114.17885765839,"2":344.6290679689588,"52":1.7054874083508,"109":0.14814756045681,"131":393.79108028279245,"328":414.75961457097253,"512":0.63355610209409,"873":0.40084347131101,"1027":3496.6526468883985,"1274":34.21831267438075,"1437":289.11803979521636,"1567":9.92334219488286,"1759":0.22246340687757,"2781":1,"2782":0.77258079843135,"2783":0.18678496381041,"2784":0.81478011121749,"2785":1.09366233612837,"2786":0.00141823951521,"2787":0.15431860619435,"2788":0.04651097891657,"2789":0.16136548766587,"2790":1.19990256791149,"2791":1.38944466675559,"2792":0.12870592626437,"2793":0.00334325143418,"2794":0.0000697192059,"2795":0.30604250318284,"2796":0.01354141981787,"2797":0.0091407678245,"2798":0.00088858177607,"2799":0.0492968834806,"2800":0.24301336573512,"2801":0.1196560272117,"2802":0.72046940022363,"2803":0.02083158478219,"2804":0.0065411299119,"2805":0.26199292252319,"2806":0.01335703762277,"2807":0.11768854057265,"2808":0.7480147688036,"2809":0.03205847465778,"2810":0.12002352461082,"2811":0.03574211350266,"2812":0.06956875027393,"2813":0.27225701061802,"2814":0.6135929240464,"2815":0.15929147153461,"2816":0.02460629860713,"2817":0.2436231636904,"2818":0.00793965859468,"2819":0.00262812089356,"2820":0.00026078929341,"2821":0.01067711030416,"2822":0.26104296584488,"2823":0.00004330598176,"2824":0.03607529115285,"2832":0.14480908659641,"3526":0.00976018036345,"3527":0.00191966608253,"3528":0.58795687924248,"3529":0.6143275938754,"3530":0.01179226245746,"3531":2.65240732488807,"3532":1,"3533":0.39096709620918,"3534":0.00162538791691,"3535":0.03883495145631,"3536":0.01757559037331,"3537":0.00749261666315,"3538":0.06382557746191,"3539":0.2906976744186,"3540":0.17314464261041,"3541":0.1295789138825,"3542":0.04149079410559,"3543":0.00068471217197,"3544":0.00002375014844,"3545":0.00655625354378,"3546":1.41043723554302,"3547":0.00935453695042,"3548":0.01179305096595,"3549":0.00024689931599,"3550":3.31761887857847,"3551":0.00234415474396,"3552":0.00065687088732,"3553":0.00507565507521,"3554":0.11215068566125,"3555":0.05636970000102,"3556":0.019488393804,"3557":0.00064199214868,"3558":0.00035077550599,"3559":0.06968641114983,"3560":0.02855291975305,"3561":0.00846011191747,"3562":2.59757801825578,"3563":1,"3564":0.27464982147762,"3565":0.01021483597874,"3566":0.26663922060289,"3567":0.00767695378474,"3568":0.36376864314296,"3569":0.14731339407261,"3570":0.00028071742894,"3571":0.02270213630281,"3572":0.00009517239056,"3573":3.5865766e-7},"timestamp":"2021-05-06T04:16:11.113Z"};

var langs = [{"code":"en","name":"English","nativeName":"English","supported":true},{"code":"fr","name":"French","nativeName":"français, langue française","supported":true},{"code":"ro","name":"Romanian, Moldavian, Moldovan","nativeName":"română","supported":true},{"code":"es","name":"Spanish; Castilian","nativeName":"español, castellano","supported":true}];

var locales = {"fr":{"next":"Cantinuer","back":"Retour","backTo":"Retour","search":{"do":"Recherche","noResults":"Auca résultat","suggestions":"Ajouter associés"},"add":"Adaugă","trash":"Supprimer","edit":"Modifier","registered":"enregistrés ()","download":"Télécharger","update":"Mise à jour","updated":"Mise à jour","lastUpdate":"Ultima actualizare","changeCurrency":"Bureau de change Mise à jour","roluri":["Administrateur","Modérateur","Invité","locataire","Propriétaire"],"nav":{"statistici":"Statistiques","liste":"Listes paiement"},"disclaimers":{"money":"le taux de change est uniquement à des fins d'information","beta":"l'application est en version bêta et peuvent avoir des effets secondaires"},"sort":{"placeholder":"Aranjează","asc":"Arrangez croissant","desc":"Descendent","by":"après","sorted":"décroissant","fields":{"createdAt":"Toilettage Covers","updatedAt":"Mise à jour"}},"counters":{"one":{"singular":{"m":"un","f":"o"}}},"sel":{"selected":"sélectionné","selecteds":"Sélectionner","select":"Sélectionner","selectAll":"Sélectionner tous","deselectAll":"désélectionner","zeroM":"Aucun","zeroF":"Aucun"},"dropFiles":"Faites glisser les fichiers ici","updates":{"available":"Mise à jour","action":"Téléchargez et redémarre","info":"une nouvelle version est prêt pour le téléchargement","currencyRates":"Curs valutar actualizat"},"forms":{"preferences":{"title":"échange","fieldsets":["affichage mis à jour"],"currencies":{"fiat":"Préférences","cryptocurrency":"Pièces de monnaies numériques traditionnels","populars":"des choix populaires"},"fields":{"currency":"Monnaie","lang":"Langue","shortKeys":"Taste rapide"}}},"taxonomies":{"apartamente":{"name":"Appartement","plural":"Hotkeys Apartments","fieldsets":{"descriere":"description","localizare":"Emplacement","registru":"Inscrivez-vous"},"fields":{"nr":"Non","suprafata":"Taille","locatari":"locataires","balanta":"solde","proprietar":"Propriétaire","camere":"Camere","etaj":"Chambres","scara":"étage","contoare":"Compteurs échelle","incasari":"produits","cheltuieli":"frais","blocId":"construction / Bloc","asociatieId":"Association"}},"asociatii":{"name":"Association","plural":"associations","fields":{"name":"Nom","organizatie":"Organisation","balanta":"solde","utilizatori":"Crew Gestion","preferinte":"Préférences","servicii":"Services"}},"blocuri":{"name":"Clădire","plural":"Bâtiments bâtiment","fields":{"name":"ID","scari":"escaliers","adresa":"Adresse","asociatieId":"Société"}},"cheltuieli":{"name":"frais","plural":"Frais","fields":{"catre":"à","suma":"Montant","facturi":"Factures","denumire":"Nom","proiect":"projet","dataScadenta":"échéance","distribuire":"Partager","modDistribuire":"Partager","asociatieId":"Association","attachments":"Pièces jointes"},"distributedTo":"distribués"},"contoare":{"name":"Contor","plural":"Compteur compteurs","fields":{"tip":"type / Nom","serviciuId":"service"}},"facturi":{"name":"facturation","plural":"Les factures","fields":{"suma":"montant","nrFactura":"Non","dataScadenta":"Scadentă la","furnizorId":"maturité fournisseur","asociatieId":"Société"}},"furnizori":{"name":"Fournisseur","plural":"Fournisseurs","fields":{"name":"Nom","organizatie":"Organisation"}},"incasari":{"name":"espèces","plural":"Produit","fields":{"suma":"montant","nrChitanta":"Non"}},"scari":{"name":"Scară","plural":"échelle des escaliers","fields":{"lift":"ascenseur","mansarda":"Grenier","name":"Non . / Nom","etaje":"Etaje"}},"servicii":{"name":"Planchers","plural":"Services","predefinite":{"apa":"Eau","electricitate":"Electricité","gaze":"Gaz","termoficare":"Chauffage","internet":"Internet","evacuare-gunoi-menajer":"ordures"},"fields":{"denumire":"Nom"}},"utilizatori":{"name":"Exhaust Nom d'utilisateur","plural":"Utilisateurs","switch":"Changer d'utilisateur","new":{"title":"Faisons connaissance!"},"fields":{"name":"Nom complet","avatar":"Avatar","codPIN":"PIN","contact":"Coordonnées","tel":"numéro de téléphone","email":"e-mail","social":"social Media","rol":"Rôle","langSwitch":"Changer de langue"}}},"welcome":{"title":"Bienvenue!","intro":"Merci d'avoir choisi d'essayer Lodger!","actions":{"import":"Importer une base","newUser":"Începe fresh"}},"footer":{"links":{"help":"Aide nouveau départ","feedback":"commentaires","thanks":"Merci","comunitate":"Communauté","update":"Mise à jour"},"ajutor":{"docs":"Documentație","support":"documentation technique"}},"errors":{"index":{"missingDB":"base de données non valide non spécifiée","invalidPluginDefinition":"Plugin invalid","couldNotWriteFile":"fichier Plugin %% n'est pas accessible en écriture"}}},"ro":{"next":"Continuă","back":"Înapoi","backTo":"Înapoi la","search":{"do":"Caută","noResults":"Niciun rezultat","suggestions":"Sugestii"},"add":"Adaugă","trash":"Șterge","edit":"Modifică","registered":"Înregistrat(ă)","download":"Descarcă","update":"Actualizează","updated":"Actualizat","lastUpdate":"Ultima actualizare","changeCurrency":"Schimbă moneda","roluri":["Administrator","Moderator","Vizitator","Locatar","Proprietar"],"nav":{"statistici":"Statistici","liste":"Liste de plată"},"disclaimers":{"money":"Cursul valutar este doar pentru scop informațional","beta":"Aplicația este în versiunea beta și poate prezenta reacții adverse"},"sort":{"placeholder":"Aranjează","asc":"Ascendent","desc":"Descendent","by":"după","sorted":"Aranjat","fields":{"createdAt":"data adaugării","updatedAt":"data ultimei actualizări"}},"counters":{"one":{"singular":{"m":"un","f":"o"}}},"sel":{"selected":"selectat","selecteds":"selectate","select":"Selectează","selectAll":"Selectează-le pe toate","deselectAll":"Deselectează-le pe toate","zeroM":"Niciunul","zeroF":"Niciuna"},"dropFiles":"Trage fișiere aici","updates":{"available":"Actualizare disponibilă","action":"Descarcă și repornește","info":"O nouă versiune este gata pentru a fi descărcată","currencyRates":"Curs valutar actualizat"},"forms":{"preferences":{"title":"Preferințe","fieldsets":["Afișaj"],"currencies":{"fiat":"Monede tradiționale","cryptocurrency":"Monede digitale","populars":"Alegeri populare"},"fields":{"currency":"Monedă","lang":"Limbă","shortKeys":"Taste rapide"}}},"taxonomies":{"apartamente":{"name":"Apartament","plural":"Apartamente","fieldsets":{"descriere":"Descriere","localizare":"Localizare","registru":"Registru"},"fields":{"nr":"Nr.","suprafata":"Suprafață","locatari":"Locatari","balanta":"Balanță","proprietar":"Proprietar","camere":"Camere","etaj":"Etaj","scara":"Scara","contoare":"Contoare","incasari":"Încasări","cheltuieli":"Cheltuieli","blocId":"Clădire / Bloc","asociatieId":"Asociație"}},"asociatii":{"name":"Asociație","plural":"Asociații","fields":{"name":"Denumire","organizatie":"Organizație","balanta":"Balanță","utilizatori":"Echipă management","preferinte":"Preferințe","servicii":"Servicii oferite"}},"blocuri":{"name":"Clădire","plural":"Clădiri","fields":{"name":"Identificator","scari":"Scări","adresa":"Adresă","asociatieId":"Asociație"}},"cheltuieli":{"name":"Cheltuială","plural":"Cheltuieli","fields":{"catre":"Către","suma":"Suma","facturi":"Facturi","denumire":"Denumire","proiect":"Proiect","dataScadenta":"Scadentă la","distribuire":"Distribuire","modDistribuire":"Distribuie","asociatieId":"Asociație","attachments":"Atașamente"},"distributedTo":"distribuită la"},"contoare":{"name":"Contor","plural":"Contoare","fields":{"tip":"Tip / Denumire","serviciuId":"Serviciu"}},"facturi":{"name":"Factură","plural":"Facturi","fields":{"suma":"Suma","nrFactura":"Nr.","dataScadenta":"Scadentă la","furnizorId":"Furnizor","asociatieId":"Asociație"}},"furnizori":{"name":"Furnizor","plural":"Furnizori","fields":{"name":"Nume","organizatie":"Organizație"}},"incasari":{"name":"Încasare","plural":"Încasări","fields":{"suma":"Suma","nrChitanta":"Nr."}},"scari":{"name":"Scară","plural":"Scări","fields":{"lift":"Ascensor","mansarda":"Mansardă","name":"Nr. / Denumire","etaje":"Etaje"}},"servicii":{"name":"Serviciu","plural":"Servicii","predefinite":{"apa":"Apă","electricitate":"Electricitate","gaze":"Gaze naturale","termoficare":"Termoficare","internet":"Internet","evacuare-gunoi-menajer":"Evacuare gunoi menajer"},"fields":{"denumire":"Denumire"}},"utilizatori":{"name":"Utilizator","plural":"Utilizatori","switch":"Schimbă utilizatorul","new":{"title":"Hai să facem cunoștință!"},"fields":{"name":"Nume complet","avatar":"Avatar","codPIN":"Cod PIN","contact":"Detalii de contact","tel":"Număr de telefon","email":"Adresă e-mail","social":"Social Media","rol":"Rol","langSwitch":"Schimbă limba"}}},"welcome":{"title":"Bun venit!","intro":"Îți mulțumim că ai ales să încerci Lodger!","actions":{"import":"Importă bază de date","newUser":"Începe fresh"}},"footer":{"links":{"help":"Ajutor","feedback":"Feedback","thanks":"Mulțumiri","comunitate":"Comunitate","update":"Actualizează"},"ajutor":{"docs":"Documentație","support":"Asistență tehnică"}},"errors":{"index":{"missingDB":"Bază de date nespecificată","invalidPluginDefinition":"Plugin invalid","couldNotWriteFile":"Fișierul %% nu poate fi scris"}}},"en":{"next":"Cantinue","back":"Back","backTo":"Back to","search":{"do":"Search","noResults":"No results","suggestions":"Related"},"add":"Add","trash":"Delete","edit":"Edit","registered":"registered ()","download":"Download","update":"Update","updated":"Updated","lastUpdate":"Updated","changeCurrency":"Currency exchange","roluri":["Administrator","Moderator","Guest","Tenant","Owner"],"nav":{"statistici":"Statistics","liste":"Lists payment"},"disclaimers":{"money":"the exchange rate is only for informational purposes","beta":"the application is in beta and may have side effects"},"sort":{"placeholder":"Arrange","asc":"Ascending","desc":"Descending","by":"after","sorted":"Grooming","fields":{"createdAt":"Covers","updatedAt":"Updated"}},"coaters":{"one":{"singular":{"m":"un","f":"o"}}},"sel":{"selected":"selected","selecteds":"Select","select":"Select","selectAll":"Select them all","deselectAll":"Unselect all","zeroM":"None","zeroF":"None"},"dropFiles":"Drag files available here","updates":{"available":"Update","action":"Download and restarts","info":"a new version is ready for download","currencyRates":"exchange"},"forms":{"preferences":{"title":"display","fieldsets":["updated"],"currencies":{"fiat":"Preferences","cryptocurrency":"Coins traditional digital currencies","populars":"popular choices"},"fields":{"currency":"Currency","lang":"Language","shortKeys":"Hotkeys"}}},"taxonomies":{"apartamente":{"name":"Apartment","plural":"Apartments","fieldsets":{"descriere":"Description","localizare":"Location","registru":"register"},"fields":{"nr":"No.","suprafata":"Size","locatari":"Tenants","balanta":"balance","proprietar":"Owner","camere":"Rooms","etaj":"Floor","scara":"scale","contoare":"Counters","incasari":"Proceeds","cheltuieli":"expenses","blocId":"Building / Block","asociatieId":"Association"}},"asociatii":{"name":"Association","plural":"Associations","fields":{"name":"Name","organizatie":"Organization","balanta":"balance","utilizatori":"Crew Management","preferinte":"Preferences","servicii":"Services"}},"blocuri":{"name":"Building","plural":"Buildings","fields":{"name":"ID","scari":"stairs","adresa":"Address","asociatieId":"Company"}},"cheltuieli":{"name":"Expense","plural":"Expenses","fields":{"catre":"To","suma":"Amount","facturi":"Invoices","denumire":"Name","proiect":"Project","dataScadenta":"maturity","distribuire":"Share","modDistribuire":"Share","asociatieId":"Association","attachments":"Attachments"},"distributedTo":"distributed"},"contoare":{"name":"Counter","plural":"counters","fields":{"tip":"Type / Name","serviciuId":"Service"}},"facturi":{"name":"Billing","plural":"Invoices","fields":{"suma":"amount","nrFactura":"No.","dataScadenta":"maturity","furnizorId":"Provider","asociatieId":"Company"}},"furnizori":{"name":"Supplier","plural":"Suppliers","fields":{"name":"Name","organizatie":"Organization"}},"incasari":{"name":"Cash","plural":"Proceeds","fields":{"suma":"amount","nrChitanta":"No."}},"scari":{"name":"scale","plural":"stairs","fields":{"lift":"elevator","mansarda":"Attic","name":"No . / Name","etaje":"Floors"}},"servicii":{"name":"Service","plural":"Services","predefinite":{"apa":"Water","electricitate":"Electricity","gaze":"Gas","termoficare":"Heating","internet":"Internet","evacuare-gunoi-menajer":"Exhaust garbage"},"fields":{"denumire":"Name"}},"utilizatori":{"name":"Username","plural":"Users","switch":"Change user","new":{"title":"Let's get acquainted!"},"fields":{"name":"Full Name","avatar":"Avatar","codPIN":"PIN","contact":"Contact details","tel":"phone number","email":"e-mail","social":"Social Media","rol":"Role","langSwitch":"Change language"}}},"welcome":{"title":"Welcome!","intro":"Thank you for choosing to try Lodger!","actions":{"import":"Import database","newUser":"Start fresh"}},"footer":{"links":{"help":"Help","feedback":"Feedback","thanks":"Thanks","comunitate":"Community","update":"update"},"ajutor":{"docs":"Documentație","support":"technical documentation"}},"errors":{"index":{"missingDB":"database unspecified invalid","invalidPluginDefinition":"Plugin invalid","couldNotWriteFile":"Plugin file %% is not writable"}}},"es":{"next":"Cantinuar","back":"Înapoi","backTo":"Volver Volver a la búsqueda","search":{"do":"Caută","noResults":"Nicia rezultat","suggestions":"No hay resultados relacionados"},"add":"Agregar","trash":"BORRAR","edit":"Modifică","registered":"Editar registrados ()","download":"Descargar","update":"Actualizar","updated":"Actualizado","lastUpdate":"Actualizado","changeCurrency":"Cambio de divisas","roluri":["Administrator","Administrador Moderador","Vizitator","Huéspedes","Propietario Inquilino"],"nav":{"statistici":"Estadísticas","liste":"Lista"},"disclaimers":{"money":"el pago de la tasa de cambio es sólo para fines informativos","beta":"la aplicación está en fase beta y pueden tener efectos secundarios"},"sort":{"placeholder":"Organizar","asc":"Ascendent","desc":"ascendente Descendente","by":"después","sorted":"HIGIENE","fields":{"createdAt":"Cubiertas","updatedAt":"Actualizado"}},"counters":{"one":{"singular":{"m":"un","f":"o"}}},"sel":{"selected":"seleccionado","selecteds":"Seleccionar","select":"Selectează","selectAll":"Seleccionar Seleccionar todos ellos","deselectAll":"Elija ninguno","zeroM":"Ninguno","zeroF":"Ninguno"},"dropFiles":"Arrastre los archivos disponibles aquí","updates":{"available":"actualización","action":"Descargar","info":"y se reinicia una nueva versión está listo para su descarga","currencyRates":"Curs valutar actualizat"},"forms":{"preferences":{"title":"intercambio de visualización","fieldsets":["actualizado"],"currencies":{"fiat":"Preferencias","cryptocurrency":"Monedas monedas digitales tradicionales","populars":"Alegeri populare"},"fields":{"currency":"opciones populares de moneda","lang":"idioma","shortKeys":"teclas de acceso rápido"}}},"taxonomies":{"apartamente":{"name":"Apartament","plural":"Apartamento Apartamentos","fieldsets":{"descriere":"Descripción","localizare":"Ubicación","registru":"Registro"},"fields":{"nr":"Nº","suprafata":"Tamaño","locatari":"Locatari","balanta":"Balanță","proprietar":"saldo inquilinos propietario","camere":"Salas","etaj":"Planta","scara":"Scara","contoare":"Contadores escala","incasari":"ingresos","cheltuieli":"Gastos","blocId":"Los gastos de construcción / Bloque","asociatieId":"Asociación"}},"asociatii":{"name":"Empresa","plural":"Asociaciones","fields":{"name":"Nombre","organizatie":"Organización","balanta":"Balanță","utilizatori":"equilibrio Crew","preferinte":"Preferencias de gestión","servicii":"Servicios"}},"blocuri":{"name":"Construcción","plural":"Edificios","fields":{"name":"ID","scari":"escaleras","adresa":"Dirección","asociatieId":"Asociación"}},"cheltuieli":{"name":"Gastos","plural":"Cheltuieli","fields":{"catre":"A","suma":"Cantidad","facturi":"Facturas","denumire":"Nombre","proiect":"Proiect","dataScadenta":"Proyecto de madurez","distribuire":"Compartir","modDistribuire":"Compartir","asociatieId":"Empresa","attachments":"Atașamente"},"distributedTo":"adjuntos distribuidos"},"contoare":{"name":"Contador","plural":"Contoare","fields":{"tip":"Tipo de contadores / Nombre","serviciuId":"Servicio de facturación"}},"facturi":{"name":"Factură","plural":"Facturas","fields":{"suma":"cantidad","nrFactura":"Nr.","dataScadenta":"Nº de madurez","furnizorId":"Proveedor","asociatieId":"Asociație"}},"furnizori":{"name":"Proveedor","plural":"Proveedores","fields":{"name":"Nombre","organizatie":"Organización"}},"incasari":{"name":"efectivo","plural":"ingresos","fields":{"suma":"cantidad","nrChitanta":"Nr."}},"scari":{"name":"Nº escala escaleras","plural":"Scări","fields":{"lift":"Ascensor","mansarda":"ascensor","name":"No ático . / Nombre","etaje":"Pisos"}},"servicii":{"name":"Servicio","plural":"Servicios","predefinite":{"apa":"Agua","electricitate":"Electricidad","gaze":"Gas","termoficare":"Calefacción","internet":"Internet","evacuare-gunoi-menajer":"basura de escape"},"fields":{"denumire":"Nombre"}},"utilizatori":{"name":"Nombre de usuario","plural":"usuarios","switch":"Cambio de usuario","new":{"title":"Vamos a conocer!"},"fields":{"name":"Detalles Nombre Completo","avatar":"Avatar","codPIN":"PIN","contact":"Contacto","tel":"número de teléfono","email":"e-mail","social":"medios de Comunicación Social","rol":"Función","langSwitch":"Schimbă limba"}}},"welcome":{"title":"Cambiar el idioma Bienvenido!","intro":"Gracias por elegir para tratar Lodger!","actions":{"import":"Importă bază de date","newUser":"importación de base de datos nuevo comienzo"}},"footer":{"links":{"help":"Ayuda","feedback":"Comentarios","thanks":"Gracias","comunitate":"Comunidad","update":"actualización"},"ajutor":{"docs":"Documentație","support":"Asistență tehnică"}},"errors":{"index":{"missingDB":"documentación técnica de base de datos no válido no especificado","invalidPluginDefinition":"Plugin invalid","couldNotWriteFile":"%% archivo plugin no se puede escribir"}}}};

var NODE_ENV = process.env.NODE_ENV,
    browser = process.browser;
/**
 * Taxonomies
 *
 * @enum {number}
 */

exports.Taxonomii = void 0;

(function (Taxonomii) {
  Taxonomii[Taxonomii["Apartament"] = 0] = "Apartament";
  Taxonomii[Taxonomii["Asociatie"] = 1] = "Asociatie";
  Taxonomii[Taxonomii["Bloc"] = 2] = "Bloc";
  Taxonomii[Taxonomii["Cheltuiala"] = 3] = "Cheltuiala";
  Taxonomii[Taxonomii["Contor"] = 4] = "Contor";
  Taxonomii[Taxonomii["Furnizor"] = 5] = "Furnizor";
  Taxonomii[Taxonomii["Incasare"] = 6] = "Incasare";
  Taxonomii[Taxonomii["Serviciu"] = 7] = "Serviciu";
  Taxonomii[Taxonomii["Utilizator"] = 8] = "Utilizator";
})(exports.Taxonomii || (exports.Taxonomii = {}));

var taxonomies = Object.keys(exports.Taxonomii).filter(function (tax) {
  return typeof exports.Taxonomii[tax] === 'number';
});
/**
 * Forms, includes each for Taxonomies
 *
 * @enum {number}
 */

var Forms;

(function (Forms) {
  Forms[Forms["Feedback"] = 0] = "Feedback";
  Forms[Forms["Financiar"] = 1] = "Financiar";
  Forms[Forms["Preferinte"] = 2] = "Preferinte";
})(Forms || (Forms = {}));
/**
 * Errors definitions

 * @enum {string}
 */


exports.Errors = void 0;

(function (Errors) {
  Errors[Errors["missingDB"] = 0] = "missingDB";
  Errors[Errors["invalidPluginDefinition"] = 1] = "invalidPluginDefinition";
  Errors[Errors["couldNotWriteFile"] = 2] = "couldNotWriteFile";
})(exports.Errors || (exports.Errors = {}));

var plugins = []; // const currencies = Object.keys(rates.data)

var defaultState = {
  hasUpdate: false,
  appPreferences: {
    display: {
      theme: 0,
      locale: 'en',
      currency: 1,
      hotkeys: true
    }
  },
  subs: {},
  modal: {
    activeDoc: null,
    closeable: true,
    sub: undefined,
    close: function () {
      if (!this.closeable) return;
      this.activeDoc = null;
      if (this.sub && this.sub.edit && typeof this.sub.edit === 'function') this.sub.edit();
    }
  },
  rates: {
    rates: rates.data,
    timestamp: rates.timestamp
  }
};
var ultimaTranzactie = {
  type: '$'
};
var taxState = {
  asociatii: {
    ultimaTranzactie: ultimaTranzactie
  },
  blocuri: {
    ultimulApNr: {
      type: 'number',
      default: 1
    }
  },
  apartamente: {
    ultimaTranzactie: ultimaTranzactie
  },
  cheltuieli: {
    progres: {
      type: 'number'
    }
  }
};
/**
 *
 * @class The main API
 * @implements {LodgerAPI}
 * @requires <rxdb> RxDatabase
 */

var Lodger =
/** @class */
function () {
  /**
   * Creates an instance of Lodger.
   * @memberof Lodger
   */
  function Lodger($taxonomies, plugins, restoreState) {
    var _this = this;

    if (plugins === void 0) {
      plugins = [];
    }

    this.$taxonomies = $taxonomies;
    this.plugins = plugins;
    this.restoreState = restoreState;
    this.appState = this.restoreState ? merge__default['default'](defaultState, this.restoreState) : defaultState;
    this.taxonomies = Object.keys(this.$taxonomies); // Events

    this._$e = new events.EventEmitter();
    this.emit = this._$e.emit;
    this.on = this._$e.on; // Bind shortcuts for every tax to `this` for easy access

    Object.assign(this, $taxonomies); // Bind lodger context to taxes for easy access

    this.taxonomies.forEach(function (tax) {
      var $tax = $taxonomies[tax];
      var form = $tax.form;
      Object.defineProperty($tax, '$lodger', {
        value: _this,
        writable: false
      });
      $tax.collection = Lodger.db[tax];

      form.defaults = function (data) {
        return __awaiter(_this, void 0, void 0, function () {
          var fields, fieldsIds;

          var _this = this;

          return __generator(this, function (_a) {
            switch (_a.label) {
              case 0:
                fields = form.fields, fieldsIds = form.fieldsIds;
                return [4
                /*yield*/
                , Promise.all(fieldsIds.filter(function (id) {
                  return fields[id].default !== undefined;
                }).map(function (fId) {
                  return __awaiter(_this, void 0, void 0, function () {
                    var field, d, val, _a;

                    var _b;

                    return __generator(this, function (_d) {
                      switch (_d.label) {
                        case 0:
                          field = fields[fId];
                          d = field.default;
                          if (!(typeof d === 'function')) return [3
                          /*break*/
                          , 2];
                          return [4
                          /*yield*/
                          , d.call(this, data)];

                        case 1:
                          _a = _d.sent();
                          return [3
                          /*break*/
                          , 3];

                        case 2:
                          _a = d;
                          _d.label = 3;

                        case 3:
                          val = _a;
                          if (val !== undefined && val !== null) return [2
                          /*return*/
                          , (_b = {}, _b[fId] = val, _b)];
                          return [2
                          /*return*/
                          ];
                      }
                    });
                  });
                }))];

              case 1:
                return [2
                /*return*/
                , _a.sent().reduce(function (a, b) {
                  return __assign(__assign({}, a), b);
                }, {})];
            }
          });
        });
      };
    });
  }

  Object.defineProperty(Lodger.prototype, "state", {
    get: function () {
      return this.appState;
    },
    set: function (s) {
      merge__default['default'](this.appState, s);
    },
    enumerable: false,
    configurable: true
  });
  /**
   * Main Init function
   *
   * Steps: (order matters)
   * 1. Hook up the taxonomies
   * 2. Lodger Forms based on taxonomies
   * 3. DB
   * 4. Store
   *
   * @param {object} options
   * @returns {Lodger}
   *
   */

  Lodger.init = function (options) {
    return __awaiter(this, void 0, void 0, function () {
      var opts, state, taxesSchemas, taxes, Taxonomies, collectionsCreator, e_1;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            opts = merge__default['default'](__assign({}, config.build), options || {});
            state = opts.state;
            return [4
            /*yield*/
            , load(taxonomies)];

          case 1:
            taxesSchemas = _a.sent();
            taxes = taxesSchemas.map(function (sch) {
              return new STaxonomy(sch, {
                timestamps: true,
                attachments: sch.name === 'cheltuiala'
              });
            });
            Taxonomies = taxes.reduce(function (a, b) {
              var _a;

              return __assign(__assign({}, a), (_a = {}, _a[b.plural] = b, _a));
            }, {});
            collectionsCreator = Object.keys(Taxonomies).reduce(function (a, b) {
              var _a;

              return __assign(__assign({}, a), (_a = {}, _a[b] = Taxonomies[b]._collectionCreator, _a));
            }, {});
            _a.label = 2;

          case 2:
            _a.trys.push([2, 4,, 5]);

            return [4
            /*yield*/
            , Lodger.bindRelationships(Taxonomies)];

          case 3:
            _a.sent();

            return [3
            /*break*/
            , 5];

          case 4:
            e_1 = _a.sent();
            console.error('Could not bind relationships', e_1);
            return [3
            /*break*/
            , 5];

          case 5:
            return [4
            /*yield*/
            , Lodger.setupRxDB(opts.db, collectionsCreator)];

          case 6:
            _a.sent();

            return [2
            /*return*/
            , new Lodger(Taxonomies, plugins, state)];
        }
      });
    });
  };
  /**
   * Assigns taxonomy relations
   * children / parents
   * parents are required for a taxonomy to be added
   * children are just relations
   *
   * @returns void
   * @param {*} $taxonomies
   * @memberof Lodger
   */


  Lodger.bindRelationships = function ($taxonomies) {
    return __awaiter(this, void 0, void 0, function () {
      var taxes;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            if (Lodger.boundRels) return [2
            /*return*/
            ];
            taxes = Object.keys($taxonomies);
            Lodger.boundRels = true;
            return [4
            /*yield*/
            , Promise.all(taxes.map(function (tax) {
              var $tax = $taxonomies[tax];
              var parents = [];
              var children = [];
              var required = $tax.form.schema.required;
              taxes.forEach(function (t) {
                var $t = $taxonomies[t];
                var _a = $t.form,
                    name = _a.name,
                    plural = _a.plural;
                var parentsKeys = [name + "Id", plural].filter(function (key) {
                  return $tax.form.fieldsIds.indexOf(key) > -1 && required.indexOf(key) > -1;
                })[0];

                if (parentsKeys) {
                  parents.push(parentsKeys.replace('Id', ''));
                }

                var childrenKeys = $t.form.fieldsIds.filter(function (key) {
                  return [$tax.form.name + "Id", $tax.form.plural].indexOf(key) > -1;
                }); // key !== 'servicii'

                if (childrenKeys && childrenKeys.length) {
                  children.push($t.form.plural);
                }
              }); // ---- SEPARATOR LOL

              if (parents && parents.length) $tax.parents = parents;

              if (children && children.length) {
                var _c = $tax.children = children.filter(function (c) {
                  return parents.map(function (p) {
                    return p.plural;
                  }).indexOf(c.replace('Id', '').plural) === -1;
                });

                var _stateField = {
                  type: 'object',
                  items: {
                    type: 'object',
                    properties: {
                      counters: {
                        type: 'object'
                      }
                    }
                  },
                  default: {
                    counters: _c.reduce(function (a, b) {
                      var _a;

                      return __assign(__assign({}, a), (_a = {}, _a[b.plural] = 0, _a));
                    }, {})
                  }
                };
                merge__default['default'](_stateField.items.properties, taxState[$tax.plural] || {});
                var state = new Field(_stateField);
                $tax.form.schema.add('state', state);
                $tax.form.internalFields['state'] = state;
              }

              return tax;
            }))];

          case 1:
            return [2
            /*return*/
            , _a.sent()];
        }
      });
    });
  };
  /**
   * Updates currency rates
   *
   * @memberof Lodger
   */


  Lodger.prototype.updateRates = function () {
    var _this = this;

    var timestamp = this.state.rates.timestamp;
    var conv = new Date(timestamp).getTime();
    var diff = Date.now() - conv;

    if (diff < 1000000) {
      notify({
        text: 'too early: ' + diff,
        type: 'error'
      });
      return;
    }

    axios__default['default'].get('https://doriandrn.github.io/currencies-rates/rates.json').then(function (data) {
      _this.rates = data.data;
    }).catch(function (e) {
      notify({
        text: 'Rates could not be fetched - ' + e,
        type: 'error'
      });
    });
  };
  /**
   * Converts diff currencies amounts
   *
   * @param {number} suma
   * @param {number} to
   * @param {number} [from=this.displayCurrency]
   * @param {Rates} [rates=this.rates]
   * @param {number} [base=2781]
   * @returns {object} converted
   * @memberof Lodger
   */


  Lodger.prototype.convert = function (suma, to, from, rates, base) {
    if (from === void 0) {
      from = this.displayCurrency;
    }

    if (rates === void 0) {
      rates = this.rates;
    }

    if (base === void 0) {
      base = 2781;
    }

    return cashify.convert(suma, {
      from: from,
      to: to,
      base: base,
      rates: rates
    });
  };

  Lodger.prototype.format = function (suma, moneda) {
    if (moneda === void 0) {
      moneda = this.displayCurrency;
    }

    return numeral__default['default'](suma).format(this.isCrypto(moneda) ? '0,0[.]00000000' : '0,0[.]00');
  };

  Lodger.prototype.isCrypto = function (moneda) {
    if (moneda === void 0) {
      moneda = this.displayCurrency;
    }

    var cryptocurrency = Lodger.currencyList.cryptocurrency;
    if (!cryptocurrency) return;
    return Object.keys(cryptocurrency).map(function (n) {
      return Number(n);
    }).indexOf(moneda) > -1;
  };
  /**
   * @alias Taxonomy.put
   *
   * Inserts/updates a new document in DB
   * updates if data has ._id key
   *
   * @param {Taxonomie} taxonomie
   * @param {Taxonomy<Taxonomie>} data
   * @returns {Promise<RxDocument<Taxonomie>>}
   * @memberof Lodger
   */


  Lodger.prototype.put = function (taxonomie, data) {
    this[taxonomie].put(data);
    var userId;

    try {
      userId = this.activeUserId;
      console.log('iu', userId);
    } catch (e) {
      console.warn('no user selected');
    } // this.istoric.push({
    //   userId,
    //   action: data._id ? 'added' : 'updated',
    //   taxonomie
    // })

  };
  /**
   * Subscribes to multiple taxonomies with
   * same criteria
   *
   * @memberof Lodger
   * @returns {void}
   *
   */


  Lodger.prototype.subscribe = function (taxonomii, criteriuCerut, subscriberName) {
    var _this = this;

    if (subscriberName === void 0) {
      subscriberName = 'main';
    }

    Object.keys(taxonomii).forEach(function (taxonomie) {
      _this.$taxonomies[taxonomie].subscribe(subscriberName, __assign({}, criteriuCerut));
    });
  };
  /**
   *
   *
   * @static
   * @memberof Lodger
   */


  Lodger.setupRxDB = function (dbOpts, collections) {
    return __awaiter(this, void 0, void 0, function () {
      var _a;

      return __generator(this, function (_b) {
        switch (_b.label) {
          case 0:
            rxdb.addRxPlugin(require('rxdb-search'));

            if (NODE_ENV === 'development') {
              rxdb.addRxPlugin(require('pouchdb-adapter-memory'));
            } else {
              if (browser) {
                rxdb.addRxPlugin(require('pouchdb-adapter-idb'));
              } else {
                rxdb.addRxPlugin(require('pouchdb-adapter-leveldb'));
              }
            }

            _a = Lodger;
            return [4
            /*yield*/
            , rxdb.createRxDatabase(dbOpts)];

          case 1:
            _a.db = _b.sent();
            return [4
            /*yield*/
            , Lodger.db.addCollections(collections)];

          case 2:
            _b.sent();

            return [2
            /*return*/
            ];
        }
      });
    });
  };
  /**
   * Extend Lodger :)
   * Todo!
   *
   * @param {LodgerPlugin} plugin
   *
   */


  Lodger.use = function (plugin) {
    if (!plugin || typeof plugin !== 'object') {
      throw new LodgerError(exports.Errors.invalidPluginDefinition);
    } // const { name } = plugin


    plugins.push(plugin);
  };
  /**
   * Destroys the Lodger instance
   *
   */


  Lodger.prototype.destroy = function () {
    return __awaiter(this, void 0, void 0, function () {
      var e_2;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            _a.trys.push([0, 2,, 3]); // await this.unsubscribeAll()


            return [4
            /*yield*/
            , STaxonomy.destroy()];

          case 1:
            // await this.unsubscribeAll()
            _a.sent();

            return [3
            /*break*/
            , 3];

          case 2:
            e_2 = _a.sent();
            console.error('Lodger could not be destroyed. Reason: ', e_2);
            return [3
            /*break*/
            , 3];

          case 3:
            return [2
            /*return*/
            ];
        }
      });
    });
  };
  /**
   * Exports the DB
   * as a YML file with ext .ldb
   * date is captured
   *
   */


  Lodger.prototype.export = function (path, cryptedData, filename) {
    return __awaiter(this, void 0, void 0, function () {
      var data, extension, date;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            if (!Lodger.db) throw new LodgerError('No database to export');
            return [4
            /*yield*/
            , Lodger.db.dump()];

          case 1:
            data = _a.sent();
            extension = 'ldb';
            if (!path) path = require('os').homeDir + "/downloads/";

            if (!filename) {
              date = new Date();
              filename = "LdgDB-" + date;
            }

            return [2
            /*return*/
            , {
              data: data,
              extension: extension,
              filename: filename
            } // node veersion, @TODO
            // fs.writeFile(`${path}/${filename}.${extension}`, yaml.stringify(json), (e: Error) => {
            //   if (e) throw new LodgerError(Errors.couldNotWriteFile)
            //   this.debug(`written ${filename}.${extension} in path`)
            // })
            ];
        }
      });
    });
  };
  /**
   * TODO!!
   */


  Lodger.prototype.import = function () {
    return __awaiter(this, void 0, void 0, function () {
      return __generator(this, function (_a) {
        return [2
        /*return*/
        ];
      });
    });
  };
  /**
   * Gets the translation for a specific item.
   *
   * @static
   * @param {string} key
   * @returns {string}
   * @memberof Lodger
   */


  Lodger.prototype.translate = function (key) {
    var i18n = this.i18n;
    return key.split('.').reduce(function (o, i) {
      return o[i];
    }, i18n);
  };

  Object.defineProperty(Lodger.prototype, "supportedLangs", {
    get: function () {
      return langs;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Lodger.prototype, "i18n", {
    get: function () {
      return locales ? locales[this.locale] : {};
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Lodger.prototype, "crumbs", {
    get: function () {
      var _this = this;

      var subs = this.state.subs;
      return Object.keys(subs).filter(function (k) {
        return (k.indexOf(_this.mainSubName) === 0 || k.indexOf('single') === 0) && subs[k].activeId || subs[k].selectedId;
      }).map(function (subDescriptor) {
        var _a = subs[subDescriptor],
            activeId = _a.activeId,
            selectedId = _a.selectedId;
        var id = selectedId || activeId;

        var tax = _this.taxonomies[Number(subDescriptor.split('-')[1])];

        return {
          id: id,
          tax: tax,
          status: true
        };
      }).reduce(function (a, b) {
        var _a;

        return __assign(__assign({}, a), (_a = {}, _a[b.tax] = {
          _id: b.id,
          status: b.status
        }, _a));
      }, {});
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Lodger.prototype, "mainSubName", {
    get: function () {
      return 'prince';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Lodger.prototype, "activeUserId", {
    get: function () {
      var subState = this.state.subs[this.mainSubName + "-" + this.taxonomies.indexOf('utilizatori')];
      if (!subState) return;
      return subState && subState.selectedId ? subState.selectedId : undefined;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Lodger.prototype, "locale", {
    /** SHORTCUTS */
    get: function () {
      var _a;

      return (_a = this.state.appPreferences) === null || _a === void 0 ? void 0 : _a.display.locale;
    },
    set: function (language) {
      var langCode = language.indexOf('-') > -1 ? language.split('-')[0] : language;
      if (langs.map(function (lang) {
        return lang.code;
      }).indexOf(langCode) < 0) throw new LodgerError('Language not supported');
      this.state.appPreferences.display.locale = langCode;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Lodger, "currencies", {
    /** Currencies and rates */
    get: function () {
      return Object.keys(rates.data).map(function (id) {
        return Number(id);
      });
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Lodger, "currencyList", {
    get: function () {
      return currencyList;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Lodger.prototype, "displayCurrency", {
    get: function () {
      return this.state.appPreferences.display.currency;
    },
    set: function (index) {
      this.appState.appPreferences.display.currency = index;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Lodger.prototype, "rates", {
    get: function () {
      var _a;

      return ((_a = this.state.rates) === null || _a === void 0 ? void 0 : _a.rates) || {};
    },
    set: function (rates) {
      Object.assign(this.state.rates, {
        rates: rates.data,
        timestamp: rates.timestamp
      });
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Lodger.prototype, "modal", {
    /** Modals */
    get: function () {
      return this.state.modal;
    },
    set: function (data) {
      merge__default['default'](this.appState.modal, data);
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Lodger.prototype, "freshDates", {
    get: function () {
      return function () {
        var createdAt = new Date().getTime();
        return {
          createdAt: createdAt,
          updatedAt: createdAt
        };
      };
    },
    enumerable: false,
    configurable: true
  });
  Lodger.boundRels = false;

  __decorate([mobx.observable], Lodger.prototype, "appState", void 0);

  __decorate([mobx.computed], Lodger.prototype, "state", null);

  __decorate([mobx.computed], Lodger.prototype, "i18n", null);

  __decorate([mobx.computed], Lodger.prototype, "crumbs", null);

  __decorate([mobx.computed], Lodger.prototype, "activeUserId", null);

  return Lodger;
}();

var fieldsets = ['descriere', 'localizare', 'registru'];
var fields$a = {
  nr: {
    type: 'number',
    search: true,
    default: function (data) {
      return __awaiter(this, void 0, void 0, function () {
        var bloc;
        return __generator(this, function (_a) {
          switch (_a.label) {
            case 0:
              if (!data.blocId) return [2
              /*return*/
              , 1];
              return [4
              /*yield*/
              , this.blocuri.getDocument(data.blocId)];

            case 1:
              bloc = _a.sent();
              return [2
              /*return*/
              , (bloc.state.ultimulApNr || 0) + 1];
          }
        });
      });
    },
    required: true,
    index: true,
    preview: 0
  },
  proprietar: {
    type: 'fullName',
    search: true,
    placeholder: 'Ion Barbu',
    oninput: {
      transform: 'capitalize'
    },
    preview: 1,
    v: 'alpha_spaces|max:32'
  },
  suprafata: {
    fieldset: 0,
    type: 'number',
    default: null,
    step: 0.01
  },
  locatari: {
    fieldset: 0,
    index: true,
    type: 'number',
    default: 2,
    min: 0,
    max: 10
  },
  camere: {
    fieldset: 0,
    type: 'number',
    index: true,
    default: 2,
    max: 12,
    min: 1
  },
  etaj: {
    fieldset: 1,
    type: 'number',
    required: true
  },
  blocId: {
    required: true,
    fieldset: 1,
    ref: 'bloc'
  },
  asociatieId: {
    required: true,
    fieldset: 1,
    ref: 'asociatie'
  },
  scara: {
    fieldset: 1,
    type: 'number',
    required: true
  },
  balanta: {
    type: '$',
    default: null,
    required: true,
    preview: 2,
    index: true
  },
  contoare: {
    type: 'contoare'
  },
  incasari: {
    type: 'array',
    ref: 'incasari',
    fieldset: 2
  },
  cheltuieli: {
    type: 'array',
    ref: 'cheltuieli',
    fieldset: 2
  }
}; // const methods = {
//   async incaseaza (data: Incasare) {
//     if (!this.balanta) this.balanta = 0
//     let incasari = this.incasari || []
//     this.balanta += data.suma
//     incasari.push(data._id)
//     this.incasari = incasari
//     await this.save()
//   }
// }

var hooks$2 = {
  postInsert: function ($ldg) {
    return function (data, $doc) {
      return __awaiter(void 0, void 0, void 0, function () {
        var bloc;
        return __generator(this, function (_a) {
          switch (_a.label) {
            case 0:
              return [4
              /*yield*/
              , $ldg.blocuri.collection.findOne(data.blocId).exec()];

            case 1:
              bloc = _a.sent();
              bloc.atomicUpdate(function (docd) {
                docd.state.ultimulApNr = data.nr;
                return docd;
              });
              return [2
              /*return*/
              , $doc];
          }
        });
      });
    };
  }
};

var Apartament = /*#__PURE__*/Object.freeze({
    __proto__: null,
    hooks: hooks$2,
    fields: fields$a,
    fieldsets: fieldsets
});

var fields$9 = {
  name: {
    required: true,
    focus: true,
    index: true,
    search: true,
    preview: 0,
    value: function (_a) {
      var activeDoc = _a.activeDoc;
      return activeDoc.name;
    },
    v: 'max:32|min:3',
    oninput: {
      transform: 'capitalize'
    }
  },
  // organizatie: {
  //   type: 'object',
  //   value: ({ activeDoc }) => activeDoc.organizatie
  //   // v: 'ro=cif|en=ssn', //TODO: stringu e doar de demo -> implement cif validation
  // },
  balanta: {
    type: '$',
    required: true,
    index: true,
    preview: 1,
    value: function (_a) {
      var activeDoc = _a.activeDoc;
      return activeDoc.balanta;
    }
  },
  // incasari: {
  //   type: 'array',
  //   ref: 'incasare',
  //   value: ({ activeDoc }) => activeDoc.incasari
  // },
  utilizatori: {
    type: 'array',
    ref: 'utilizator',
    required: true,
    default: function () {
      [this.activeUserId];
    },
    value: function (_a) {
      var activeDoc = _a.activeDoc;
      return activeDoc.utilizatori;
    }
  },
  servicii: {
    type: 'array',
    ref: 'serviciu',
    value: function (_a) {
      var activeDoc = _a.activeDoc;
      return activeDoc.servicii;
    }
  } // furnizori: {
  //   type: 'array',
  //   ref: 'furnizor',
  //   value: ({ activeDoc }) => activeDoc.furnizori
  // },
  // preferinte: {
  //   value: ({ activeDoc }) => activeDoc.preferinte,
  //   type: 'object'
  // }

};
var methods$2 = {
  initBalanta: function (data) {
    return __awaiter(this, void 0, void 0, function () {
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            if (this.balanta !== undefined) return [2
            /*return*/
            ];
            this.balanta = data.balanta;
            return [4
            /*yield*/
            , this.save()];

          case 1:
            _a.sent();

            return [2
            /*return*/
            ];
        }
      });
    });
  },
  incaseaza: function (data) {
    return __awaiter(this, void 0, void 0, function () {
      var incasari;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            if (!this.balanta) this.balanta = 0;
            incasari = this.incasari || [];
            this.balanta += data.suma;
            incasari.push(data._id);
            this.incasari = incasari;
            return [4
            /*yield*/
            , this.save()];

          case 1:
            _a.sent();

            return [2
            /*return*/
            ];
        }
      });
    });
  },
  toggle_serviciu: function (serviciu) {
    return __awaiter(this, void 0, void 0, function () {
      var servicii, index;
      return __generator(this, function (_a) {
        if (!serviciu) return [2
        /*return*/
        ];
        servicii = this.servicii;
        if (!servicii) servicii = [];
        index = servicii.indexOf(serviciu);

        if (index > -1) {
          servicii.splice(index, 1);
        } else {
          servicii.push(serviciu);
        } // this.update('servicii', servicii)


        this.update({
          $set: {
            servicii: servicii
          }
        });
        return [2
        /*return*/
        ];
      });
    });
  },
  UPDATEAZA: function (fields) {
    return __awaiter(this, void 0, void 0, function () {
      var _this = this;

      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            // TODO: nu permite updatarea anumitor chei
            Object.keys(fields).forEach(function (camp) {
              _this[camp] = fields[camp];
            });
            return [4
            /*yield*/
            , this.save()];

          case 1:
            _a.sent();

            return [2
            /*return*/
            ];
        }
      });
    });
  }
};
var statics = {// selected: async function (id) {
  //   // console.log('STATIC!', this)
  //   return await this.findOne(id).exec()
  // }
}; // DRY: la buatoane, daca au 'click', n-au nevoie de id

var setari = {
  date: {
    fields: [{
      type: 'button',
      click: 'exportDb'
    }, {
      type: 'button',
      click: 'importDb'
    }]
  },
  periculoase: {
    order: -1,
    avansat: true,
    fields: [{
      type: 'button',
      click: 'sterge'
    }]
  }
};

var Asociatie = /*#__PURE__*/Object.freeze({
    __proto__: null,
    fields: fields$9,
    methods: methods$2,
    statics: statics,
    setari: setari
});

var fields$8 = {
  name: {
    placeholder: 'ex. M11, COCOR-2, A3...',
    oninput: {
      transform: 'uppercase:all'
    },
    type: 'buildingName',
    required: true,
    preview: 0,
    index: true,
    search: true,
    v: 'min:1|max:20',
    focus: true,
    value: function (_a) {
      var activeDoc = _a.activeDoc;
      return activeDoc.name;
    }
  },
  scari: {
    type: 'scari',
    preview: 1,
    default: [{
      id: 1,
      etaje: 4,
      lift: false,
      mansarda: false
    }],
    value: function (_a) {
      var activeDoc = _a.activeDoc;
      return activeDoc.scari;
    }
  },
  adresa: {
    type: 'textarea',
    search: true,
    value: function (_a) {
      var activeDoc = _a.activeDoc;
      return activeDoc.adresa;
    }
  },
  asociatieId: {
    required: true,
    ref: 'asociatie',
    value: function (_a) {
      var g = _a.g;
      return g.asociatieId;
    }
  }
};
/**
 * It's assumed the item has an _id
 */
// Building
//   @parents Taxonomies.Organization (generated for UX purposes)
//   _id
//     value // this means it has a value, it's stored in the store and so it will get it from there
//   !name : string // ! = indexable
//     placeholder 'ex. M11, COCOR-2, A3...'
//     validate 'min:1|max:20'
//     focus true // boolean or function
//     value ({ activeDoc }) => activeDoc.name
//     oninput
//       transform 'uppercase:all'
//   address ?: Textarea
//     validate 'min:20'
//   scari ?: Scara[] // this won't be indexed,  cant search for it

var Bloc = /*#__PURE__*/Object.freeze({
    __proto__: null,
    fields: fields$8
});

var fields$7 = {
  asociatieId: {
    ref: 'asociatii',
    required: true,
    index: true,
    final: true
  },
  denumire: {
    preview: 0,
    search: true
  },
  dataScadenta: {
    type: 'dateTime',
    final: true,
    preview: 0,
    default: function () {
      return new Date().getTime() + 2629743830;
    } // 1mo

  },
  catre: {
    final: true,
    required: true,
    ref: 'furnizori'
  },
  suma: {
    type: '$',
    required: true,
    index: true,
    preview: 1,
    final: true
  },
  modDistribuire: {
    type: 'number',
    default: 0,
    final: true,
    options: ['suprafata', 'locatari', 'contor', 'custom']
  },
  distribuire: {
    final: true,
    type: 'selApartamente',
    default: function () {
      return {};
    }
  },
  snapshotsApartamente: {
    final: true,
    type: 'object',
    default: function () {
      return {};
    }
  }
};
var methods$1 = {
  /**
   * Distribuie suma la apartamente dupa ids si mod
   * @param suma
   * @param ids
   * @param mod
   */
  distribuie: function (valoare, ids, mod) {
    if (mod === void 0) {
      mod = 0;
    }

    if (valoare === undefined || ids === undefined) return;
    var sub = this.apartamente.subscribers["single-cheltuiala"];
    var items = sub.items;
    var distrKey = fields$7.modDistribuire.options[mod];
    var allUnits = ids.reduce(function (a, b) {
      return a + items[b][distrKey];
    }, 0);
    var cpu = Number(valoare) / allUnits;
    return ids.reduce(function (a, b) {
      var _a;

      return __assign(__assign({}, a), (_a = {}, _a[b] = items[b][distrKey] * cpu, _a));
    }, {});
  },

  /**
   * Snapshots aps as they are before doing a transaction
   *
   * @param ids
   */
  ssAps: function (ids) {
    var apartamente = this.apartamente;
    var sub = apartamente.subscribers["single-cheltuiala"];
    var items = sub.items;
    return ids.reduce(function (a, b) {
      var _a;

      return __assign(__assign({}, a), (_a = {}, _a[b] = apartamente.form.fieldsIds.reduce(function (x, y) {
        var _a;

        return __assign(__assign({}, x), (_a = {}, _a[y] = items[b]._doc ? items[b]._doc._data[y] : apartamente.data[b]._doc._data[y], _a));
      }, {}), _a));
    }, {});
  }
};

var Cheltuiala = /*#__PURE__*/Object.freeze({
    __proto__: null,
    fields: fields$7,
    methods: methods$1
});

var fields$6 = {
  tip: {
    preview: 0,
    search: true
  }
};

var Contor = /*#__PURE__*/Object.freeze({
    __proto__: null,
    fields: fields$6
});

var fields$5 = {
  suma: {
    type: '$',
    preview: 0,
    index: true,
    required: true
  },
  nrFactura: {
    type: 'number',
    search: true,
    default: 1,
    index: true,
    value: function (g) {
      return Number(g.nrUltimaChitanta || 0) + 1;
    }
  },
  dataScadenta: {
    type: 'date',
    preview: 1
  },
  furnizorId: {
    required: true,
    type: 'search',
    ref: 'furnizori'
  },
  asociatieId: {
    required: true,
    index: true,
    value: function (g) {
      return g['asociatie/active'] || g['asociatie/selected'];
    }
  }
};

var Factura = /*#__PURE__*/Object.freeze({
    __proto__: null,
    fields: fields$5
});

var fields$4 = {
  subiect: {
    required: true
  },
  tip: {
    type: 'select',
    options: ['bug', 'enhacement', 'feature', 'other'],
    default: 'bug',
    required: true
  },
  mesaj: {
    required: true,
    type: 'textarea',
    placeholder: 'Părerea / Sugestia / Critica ta'
  }
};

var Feedback = /*#__PURE__*/Object.freeze({
    __proto__: null,
    fields: fields$4
});

var fields$3 = {
  name: {
    required: true,
    preview: 0,
    index: true,
    search: true
  },
  servicii: {
    type: 'servicii',
    required: true,
    value: function (_a) {
      var activeDoc = _a.activeDoc;
      return activeDoc.servicii;
    },
    ref: 'serviciu'
  },
  organizatie: {
    type: 'organizatie'
  }
};

var Furnizor = /*#__PURE__*/Object.freeze({
    __proto__: null,
    fields: fields$3
});

var fields$2 = {
  suma: {
    type: '$',
    preview: 1,
    index: true,
    required: true
  },
  nrChitanta: {
    type: 'number',
    default: 1,
    search: true,
    preview: 0,
    index: true,
    value: function (_a) {
      var activeDoc = _a.activeDoc;
      return (activeDoc.nrUltimaChitanta || 0) + 1;
    }
  },
  //aka DE LA
  apartamentId: {
    required: true,
    type: 'search',
    ref: 'apartamente',
    preview: 2
  },
  cheltuieli: {
    ref: 'cheltuieli',
    preview: 3
  },
  // ASTEA TREBUIE SA RAMANA IN CAZ CA UN APARTAMENT SE STERGE
  // TREBUIE SA FIGUREZE
  /// !!!!!!!!!!!!!!!!
  blocId: {
    required: true,
    index: true,
    value: function (g) {
      return g['bloc/selected'].id;
    }
  },
  asociatieId: {
    required: true,
    index: true,
    value: function (g) {
      return g['asociatie/selected'].id;
    }
  },
  plata: {
    type: 'object',
    default: function () {
      return {
        metoda: 'fiat:banca',
        // metoda: 'crypto:nano',
        asociatieBalAnte: {
          moneda: 1,
          value: 1
        },
        apartamentBalAnte: {
          moneda: 1,
          value: 1
        },
        achitata: {
          status: false,
          la: 0
        },
        curs: 1
      };
    }
  }
};
var hooks$1 = {
  postInsert: function (ctx) {
    var convert = ctx.convert,
        rates = ctx.rates;
    var rels = ['asociatie', 'apartament'];
    return function (data, $doc) {
      return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
          switch (_a.label) {
            case 0:
              data.plata = {
                curs: rates[data.suma.moneda]
              };
              return [4
              /*yield*/
              , Promise.all(rels.map(function (rel) {
                return __awaiter(void 0, void 0, void 0, function () {
                  var doc, newConvertedValue;
                  return __generator(this, function (_a) {
                    switch (_a.label) {
                      case 0:
                        return [4
                        /*yield*/
                        , ctx[rel.plural].collection.findOne(data[rel + "Id"]).exec() // const { balanta: { moneda, value } } = doc
                        ];

                      case 1:
                        doc = _a.sent();
                        newConvertedValue = convert(data.suma.value, data.suma.moneda, doc.balanta.moneda, ctx.rates);
                        doc.atomicUpdate(function (docdata) {
                          data.plata[rel + "BalAnte"] = __assign({}, docdata.balanta);
                          docdata.balanta.value = Number(docdata.balanta.value) + Number(newConvertedValue); // if (rel === 'asociatie') {
                          //   ctx.state.
                          // }

                          return docdata;
                        });
                        return [2
                        /*return*/
                        ];
                    }
                  });
                });
              }))];

            case 1:
              _a.sent();

              $doc.atomicUpdate(function (docdata) {
                docdata.plata = data.plata;
                return docdata;
              });
              return [2
              /*return*/
              , $doc];
          }
        });
      });
    };
  }
};

var Incasare = /*#__PURE__*/Object.freeze({
    __proto__: null,
    fields: fields$2,
    hooks: hooks$1
});

var fields$1 = {
  /**
   * desi globale, serviciile sunt pt asociatii.
   * excludem asta din db, pastram pt referinta
   */
  // asociatieId: {
  //   ref: 'asociatie'
  // },
  denumire: {
    required: true,
    preview: 0,
    primary: true,
    index: true,
    search: true
  } // contoare: {
  //   type: 'contoare',
  //   ref: 'contoare',
  //   preview: 1
  // }

};
var predefinite = ['apa', 'electricitate', 'gaze', 'termoficare', 'internet', 'evacuare-gunoi-menajer'];
var hooks = {
  // serviciile predifinite pe empty
  empty: function () {
    var _this = this;

    predefinite.map(function (service) {
      return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
          switch (_a.label) {
            case 0:
              return [4
              /*yield*/
              , this.put({
                denumire: service
              })];

            case 1:
              _a.sent();

              return [2
              /*return*/
              ];
          }
        });
      });
    });
  }
};

var Serviciu = /*#__PURE__*/Object.freeze({
    __proto__: null,
    fields: fields$1,
    predefinite: predefinite,
    hooks: hooks
});

var Tranzactie = /*#__PURE__*/Object.freeze({
    __proto__: null
});

var Roluri;

(function (Roluri) {
  Roluri[Roluri["admin"] = 0] = "admin";
  Roluri[Roluri["moderator"] = 1] = "moderator";
  Roluri[Roluri["vizitator"] = 2] = "vizitator";
  Roluri[Roluri["locatar"] = 3] = "locatar";
  Roluri[Roluri["proprietar"] = 4] = "proprietar";
})(Roluri || (Roluri = {}));

var fields = {
  // permisiuni: {
  //   type: 'object',
  //   items: {
  //     type:
  //   },
  //   default: ($ldg) => {
  //   }
  // },
  avatar: {
    type: 'userAvatar',
    preview: 0
  },
  name: {
    type: 'fullName',
    required: true,
    primary: true,
    preview: 1,
    focus: true,
    search: true,
    oninput: {
      transform: 'capitalize:all'
    },
    value: function (_a) {
      var activeDoc = _a.activeDoc;
      return activeDoc.name;
    }
  },
  contact: {
    type: 'contactFields',
    default: function () {
      return {
        email: [],
        tel: []
      };
    },
    value: function (_a) {
      var activeDoc = _a.activeDoc;
      return activeDoc.contact;
    }
  },
  // preferinte: {
  //   type: 'object',
  //   default: {
  //     locale: () => 'ro-RO'
  //   }
  // },
  rol: {
    type: 'number',
    min: 0,
    max: 6,
    default: 1
  },
  codPIN: {
    type: 'number',
    min: 1000,
    max: 9999,
    // encrypted: true,
    required: true
  }
};
var methods = {
  UPDATEAZA: function (campuri) {
    return __awaiter(this, void 0, void 0, function () {
      var _this = this;

      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            // TODO: nu permite updatarea anumitor chei
            Object.keys(campuri).forEach(function (camp) {
              _this[camp] = campuri[camp];
            });
            return [4
            /*yield*/
            , this.save()];

          case 1:
            _a.sent();

            return [2
            /*return*/
            ];
        }
      });
    });
  }
}; // const hooks = {

var Utilizator = /*#__PURE__*/Object.freeze({
    __proto__: null,
    fields: fields,
    methods: methods
});

exports.Lodger = Lodger;
exports.notify = notify;
exports.taxonomies = taxonomies;
